CREATE Procedure prLoadMailConfirm
	(
		@varSendMailId varchar(255),
		@varDomain varchar(255),
		@varRecId varchar(30)
	)
As
Declare @iTableNo int,
	@iDomainNo int,
	@strSql nvarchar(1000),
	@strQry varchar(100),
	@strTableName varchar(30),
	@param nvarchar(400)

If Not Exists(Select User_No From Mail_User Where User_Id = @varRecId And User_Domain = @varDomain)
Begin
	Return -1
End

If Not Exists(Select Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @varDomain)
Begin
	Return -2
End

Select @iDomainNo = Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @varDomain

Select @iTableNo = Nm_Tbl_No From Mail_User Where User_Id = @varRecId And User_Domain = @varDomain

Set @strTableName = 'Nm_Mail_Content_' + RTrim(Cast(@iDomainNo As varchar(4))) + '_' + RTrim(Cast(@iTableNo As varchar(4)))

Set @strSql = 'Select User_Mailbox_Path, IsNull(Mc_Mailbox_No, 1) As Mc_Mailbox_No '
Set @strSql = @strSql + ' From Mail_User as Mu join ' + @strTableName + ' as NM '
Set @strSql = @strSql + ' on Mu.user_id = NM.MC_User_Id '
Set @strSql = @strSql + ' Where Mu.user_id = ''' + @varRecId + ''' '
Set @strSql = @strSql + ' and Mu.user_domain =''' + @varDomain + ''' '
Set @strSql = @strSql + ' and NM.Mc_Filename = ''' + @varSendMailId + ''' '


exec sp_executeSql @strSql

GO

CREATE Procedure prLoadRecMailConfirm
	(
		@varSendMailId varchar(255),
		@varUserId varchar(30),
		@varDomain varchar(255)
	)
As
If Not Exists(Select User_No From Mail_User Where User_Id = @varUserId And User_Domain = @varDomain)
Begin
	Return -1
End

If Not Exists(Select Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @varDomain)
Begin
	Return -2
End

SELECT RECEIVE_EMAIL,Save_Mail_id 
FROM Mail_confirm 
WHERE user_id = @varUserId
	and user_domain = @varDomain
	and send_mail_id = @varSendMailId

GO

CREATE Procedure prListRejectEmailAddr
	(
		@iPage int,
		@iPageSize int,
		@varUserId varchar(30),
		@varDomain varchar(255),
		@varsch varchar(255),
		@iTotCnt int OUTPUT
	)
As
Set Transaction Isolation Level Read UnCommitted
Set NoCount On

Declare	@strSql nvarchar(1600),
	@strQry nvarchar(400),
	@param nvarchar(400),
	@Idx int,
	@iCount int

If @varsch = ''
Begin
	Select @iTotCnt = Count(Nre_Idx) From NM_REJECT_EMAIL Where NRE_USER_ID= @varUserId And NRE_DOMAIN = @varDomain
End
Else
Begin
	Select @iTotCnt = Count(Nre_Idx) From NM_REJECT_EMAIL Where NRE_USER_ID= @varUserId And NRE_DOMAIN = @varDomain And NRE_EMAIL Like '%' + @varsch + '%'
End

Set @iCount = ((@iPage - 1) * @iPageSize) + 1

If @varsch = ''
Begin
	If @iCount <= @iTotCnt And @iPageSize > 0
	Begin
		If @iPage = 1
		Begin
			Set @strSql = 'Select Top 1 @rejectIdx = Nre_Idx From Nm_Reject_Email '
			Set @strSql = @strSql + ' Where Nre_User_Id = @userId And Nre_Domain = @domain Order By Nre_Idx Desc '
		End	
		Else
		Begin
			Set @strSql = 'Select Top ' + Convert(varchar(10), @iCount) + ' @rejectIdx = Nre_Idx From Nm_Reject_Email '
			Set @strSql = @strSql + ' Where Nre_User_Id = @userId And Nre_Domain = @domain Order By Nre_Idx Desc '
		End

		Set @param = '@rejectIdx int OUTPUT, @userId varchar(30), @domain varchar(255)'

		exec sp_executeSql @strSql, @param, @rejectIdx = @Idx OUTPUT, @userId = @varUserId, @domain = @varDomain

		Set @strSql = 'Select Top ' + Convert(varchar(10), @iPageSize) + ' Nre_Idx, Nre_Email From  '
		Set @strSql = @strSql + ' (Select Top ' + Convert(varchar(10), @iPageSize) + ' * From Nm_Reject_Email Where Nre_Idx <= @rejectIdx And '
		Set @strSql = @strSql + ' Nre_User_Id = @userId And Nre_Domain = @domain Order By Nre_Idx Desc) As Reject '
		Set @strSql = @strSql + ' Where Nre_User_Id = @userId And Nre_Domain = @domain Order By Nre_Idx Desc '
		Set @param = '@rejectIdx int, @userId varchar(30), @domain varchar(255) '

		exec sp_executeSql @strSql, @param, @rejectIdx = @Idx, @userId = @varUserId, @domain = @varDomain
	End
	Else
		Select * From Nm_Reject_Email Where Nre_User_Id = @varUserId And Nre_Domain = @varDomain Order By Nre_Idx Desc
End
Else
Begin
	If @iCount <= @iTotCnt And @iPageSize > 0
	Begin
		If @iPage = 1
		Begin
			Set @strSql = 'Select Top 1 @rejectIdx = Nre_Idx From Nm_Reject_Email '
			Set @strSql = @strSql + ' Where Nre_User_Id = @userId And Nre_Domain = @domain And NRE_EMAIL Like ''%' + @varsch + '%'' Order By Nre_Idx Desc '
		End	
		Else
		Begin
			Set @strSql = 'Select Top ' + Convert(varchar(10), @iCount) + ' @rejectIdx = Nre_Idx From Nm_Reject_Email '
			Set @strSql = @strSql + ' Where Nre_User_Id = @userId And Nre_Domain = @domain And NRE_EMAIL Like ''%' + @varsch + '%'' Order By Nre_Idx Desc '
		End

		Set @param = '@rejectIdx int OUTPUT, @userId varchar(30), @domain varchar(255)'

		exec sp_executeSql @strSql, @param, @rejectIdx = @Idx OUTPUT, @userId = @varUserId, @domain = @varDomain

		Set @strSql = 'Select Top ' + Convert(varchar(10), @iPageSize) + ' Nre_Idx, Nre_Email From  '
		Set @strSql = @strSql + ' (Select Top ' + Convert(varchar(10), @iPageSize) + ' * From Nm_Reject_Email Where Nre_Idx <= @rejectIdx And '
		Set @strSql = @strSql + ' Nre_User_Id = @userId And Nre_Domain = @domain And NRE_EMAIL Like ''%' + @varsch + '%'' Order By Nre_Idx Desc) As Reject '
		Set @strSql = @strSql + ' Where Nre_User_Id = @userId And Nre_Domain = @domain And NRE_EMAIL Like ''%' + @varsch + '%'' Order By Nre_Idx Desc '
		Set @param = '@rejectIdx int, @userId varchar(30), @domain varchar(255) '

		exec sp_executeSql @strSql, @param, @rejectIdx = @Idx, @userId = @varUserId, @domain = @varDomain
	End
	Else
		Select * From Nm_Reject_Email Where Nre_User_Id = @varUserId And Nre_Domain = @varDomain And NRE_EMAIL Like '%' + @varsch + '%' Order By Nre_Idx Desc
End

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO

CREATE Procedure prAutoDeleteListMail
(
	@strUserId varchar(30),
	@strDomain varchar(255)
)
As
Declare @iTableNo int,
	@iDomainNo int,
	@iCurrent_Size bigint,
	@strSql nvarchar(1200),
	@param nvarchar(400),
	@strTableName varchar(30),
	@iIdx int

If Not Exists(Select User_No From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain)
Begin
	Return -1
End

If Not Exists(Select Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @strDomain)
Begin
	Return -2
End

Select @iDomainNo = Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @strDomain

Select @iTableNo = Nm_Tbl_No From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain

Set @strTableName = 'Nm_Mail_Content_' + RTrim(Cast(@iDomainNo As varchar(4))) + '_' + RTrim(Cast(@iTableNo As varchar(4)))

-- Ⱓ    
Set @strSql = 'Select Mc_Mailbox_No, Mc_Filename From ' + @strTableName + ' Left Join '
Set @strSql = @strSql + '(Select M_Idx, M_User_Id, M_User_Domain, M_Save_Day From Nm_Mail_Box Where M_Save_Day > 0) As Mb On '
Set @strSql = @strSql + ' Mc_Mailbox_Idx = M_Idx And Mc_User_Id = M_User_Id And Mc_Domain = M_User_Domain '
Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' Mc_Send_Date < DateAdd(Day, M_Save_Day * -1, GetDate()) And Mc_User_Id = @userId And Mc_Domain = @domain '

Set @param = '@userId varchar(30), @domain varchar(255)'

exec sp_ExecuteSql @strSql, @param, @userId = @strUserId, @domain = @strDomain

-- Ⱓ   ϴ 
Set @strSql = 'Delete ' + @strTableName + ' From ' + @strTableName + ' Left Join '
Set @strSql = @strSql + '(Select M_Idx, M_User_Id, M_User_Domain, M_Save_Day From Nm_Mail_Box Where M_Save_Day > 0) As Mb On '
Set @strSql = @strSql + ' Mc_Mailbox_Idx = M_Idx And Mc_User_Id = M_User_Id And Mc_Domain = M_User_Domain '
Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' Mc_Send_Date < DateAdd(Day, M_Save_Day * -1, GetDate()) And Mc_User_Id = @userId And Mc_Domain = @domain '

Set @param = '@userId varchar(30), @domain varchar(255)'

exec sp_ExecuteSql @strSql, @param, @userId = @strUserId, @domain = @strDomain

--  Ϲڽ ü  ü 뷮 Ʈ
Set @strSql = 'Update Nm_Mail_Box Set '
Set @strSql = @strSql + ' M_Mail_Count = IsNull(Mail.Mail_Count, 0), M_Use_Size = IsNull(Mail.Mail_Size, 0) '
Set @strSql = @strSql + ' From Nm_Mail_Box Left Outer Join '
Set @strSql = @strSql + ' (Select Mc_User_Id, Mc_Domain, Count(Mc_Mailbox_No) as mail_Count, Sum(Mc_Size)as mail_size, Mc_Mailbox_Idx '
Set @strSql = @strSql + ' From ' + @strTableName + ' '
Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' Mc_User_Id = @userId And Mc_Domain = @domain '
Set @strSql = @strSql + ' Group By Mc_User_Id, Mc_Domain, Mc_Mailbox_Idx) As Mail On '
Set @strSql = @strSql + ' M_Idx = Mc_Mailbox_Idx And M_User_Id = Mc_User_Id And M_User_Domain = Mc_Domain '
Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' M_User_Id = @userId And M_User_Domain = @domain '

Set @param = '@userId varchar(30), @domain varchar(255)'

exec sp_ExecuteSql @strSql, @param, @userId = @strUserId, @domain = @strDomain

--  Ϲڽ  ϰ Ʈ
Set @strSql = 'Update Nm_Mail_Box Set '
Set @strSql = @strSql + ' M_No_Read_Count = IsNull(Mail.Mail_Count, 0) '
Set @strSql = @strSql + ' From Nm_Mail_Box Left Outer Join '
Set @strSql = @strSql + ' (Select Mc_User_Id, Mc_Domain, Count(Mc_Mailbox_No) as mail_Count, Mc_Mailbox_Idx '
Set @strSql = @strSql + ' From ' + @strTableName + ' '
Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' Mc_Is_Read = 0 And Mc_User_Id = @userId And Mc_Domain = @domain '
Set @strSql = @strSql + ' Group By Mc_User_Id, Mc_Domain, Mc_Mailbox_Idx) As Mail On '
Set @strSql = @strSql + ' M_Idx = Mc_Mailbox_Idx And M_User_Id = Mc_User_Id And M_User_Domain = Mc_Domain '
Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' M_User_Id = @userId And M_User_Domain = @domain '

Set @param = '@userId varchar(30), @domain varchar(255)'

exec sp_ExecuteSql @strSql, @param, @userId = @strUserId, @domain = @strDomain

-- [2009-04-08]   뷮 Ʈ
Select @iCurrent_Size = Sum(M_Use_Size) From Nm_Mail_Box Where M_User_Id = @strUserId And M_User_Domain = @strDomain
Update Mail_User Set Current_Size = IsNull(@iCurrent_Size, 0) Where User_Id = @strUserId And User_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO

CREATE Procedure prMailboxSize
(
	@strUserId varchar(30),
	@strDomain varchar(255),
	@iMailboxIdx smallInt,
	@strIsDefault char(1)
)
As
If @iMailboxIdx = 0
Begin
	Select 
		Sum(M_Mail_Count) As M_Mail_Count, Sum(M_No_Read_Count) As M_No_Read_Count,
		( 
			Select Sum(M_Use_Size)	
			From	Nm_Mail_Box	
			Where M_User_Id = @strUserId And M_User_Domain = @strDomain
		) as M_Use_Size
	From 
		Nm_Mail_Box 
	Where 
		M_User_Id = @strUserId And M_User_Domain = @strDomain
--10.02.04  ī ȵǰ ܽŴ.
		AND M_IDX != '101'
End
Else
Begin
	Select 
		M_Idx, M_Mailbox_Name, M_Mail_Count, M_No_Read_Count,
		( 
			Select Sum(M_Use_Size)	
			From	Nm_Mail_Box	
			Where M_Is_Default = @strIsDefault And M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain
		) as M_Use_Size
	From 
		Nm_Mail_Box 
	Where 
		M_Is_Default = @strIsDefault And M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain
--10.02.04  ī ȵǰ ܽŴ.
		AND M_IDX != '101'
End

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO

CREATE Procedure prListMail
(
	@strUserId varchar(30),
	@strDomain varchar(255),
	@iMailboxIdx smallInt,
	@strSearchType char(1),
	@strSearchValue varchar(255),
	@strStartDate varchar(10),
	@strEndDate varchar(10),
	@iPage int,
	@iPageSize int,
--2010.03.22 ߰
	@strIs_Read varchar(4),
--
	@iTotalCount int OUTPUT,
	@iNoReadCount int OUTPUT
)

As
Declare @iTableNo int,
	@iDomainNo int,
	@strSql nvarchar(1600),
	@strQry nvarchar(400),
	@param nvarchar(400),
	@strTableName varchar(30),
	@iCount int,
	@dReceiveDate datetime,
--2010.03,22 ߰
	@strQry2 nvarchar(400)
--

If Not Exists(Select User_No From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain)
Begin
	Return -1
End

If Not Exists(Select Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @strDomain)
Begin
	Return -2
End

Select @iDomainNo = Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @strDomain

Select @iTableNo = Nm_Tbl_No From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain

If @strSearchType = '0'
Begin
	--  ˻
	Set @strQry = ' Mc_Subject Like ''%' + @strSearchValue + '%'' And '
End
Else
Begin
	If @strSearchType = '1'
	Begin
		--  ˻
		Set @strQry = ' (Mc_Body_Html Like ''%' + @strSearchValue + '%'' Or Mc_Body_Text Like ''%' + @strSearchValue + '%'') And '
	End
	Else
	Begin
		If @strSearchType = '2'
		Begin
			--  +  ˻
			Set @strQry = ' (Mc_Subject Like ''%' + @strSearchValue + '%'' Or Mc_Body_Html Like ''%' + @strSearchValue + '%'' Or Mc_Body_Text Like ''%' + @strSearchValue + '%'') And '
		End
		Else
		Begin
			If @strSearchType = '3'
			Begin
				-- ޴ ˻
				Set @strQry = ' Mc_To Like ''%' + @strSearchValue + '%'' And '
			End
			Else
			Begin
				If @strSearchType = '4'
				Begin
					--  ˻
					Set @strQry = ' Mc_From Like ''%' + @strSearchValue + '%'' And '
				End
			End
		End
	End
End
--2010.01.28 ϳ Ÿ̰ ϳ ɸŸε   ׳ ؼ  ¥  ʾ. ׷ Mc_Receive_Date ͸ .
If @strStartDate <> '' And @strEndDate <> ''
Begin
	Set @strQry = @strQry + ' (convert(varchar(10),Mc_Receive_Date,112) >= ''' + @strStartDate + ''' And convert(varchar(10),Mc_Receive_Date,112) <= ''' + @strEndDate + ''') And '
End
Else
Begin
	If @strStartDate <> ''
	Begin
		Set @strQry = @strQry + ' convert(varchar(10),Mc_Receive_Date,112) >= ''' + @strStartDate + '''  And '
	End
	Else
	Begin
		If @strEndDate <> ''
		Begin
			Set @strQry = @strQry + ' convert(varchar(10),Mc_Receive_Date,112) <= ''' + @strEndDate + ''' And '
		End
	End
End

If @strQry Is Null
	Set @strQry = ''

If @iMailboxIdx = 0
	Set @strQry2 = ' '
Else
	Set @strQry2 = ' Mc_Mailbox_Idx = @mailbox And'

Set @strTableName = 'Nm_Mail_Content_' + RTrim(Cast(@iDomainNo As varchar(4))) + '_' + RTrim(Cast(@iTableNo As varchar(4)))

-- ü  
Set @strSql = 'Select @totalCount = Count(*) From ' + @strTableName + ' '
Set @strSql = @strSql + ' Where ' + @strQry + @strQry2 + '   Mc_User_Id = @userId And Mc_Domain = @domain '
Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255), @totalCount int OUTPUT'

exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain, @totalCount = @iTotalCount OUTPUT

print @strSql
--   ϰ
Set @strSql = 'Select @noReadCount = Count(*) From ' + @strTableName + ' '
Set @strSql = @strSql + ' Where ' + @strQry + ' Mc_Is_Read = 0 And ' +@strQry2+ ' Mc_User_Id = @userId And Mc_Domain = @domain '
Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255), @noReadCount Int OUTPUT'

exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain, @noReadCount = @iNoReadCount OUTPUT


Set @iCount = ((@iPage - 1) * @iPageSize) + 1

If @strIs_Read = '0'
Begin
	If @iCount <= @iTotalCount And @iPageSize > 0
	Begin	
		If @iPage = 1
		Begin
			Set @strSql = 'Select Top 1 @receiveDate = Mc_Receive_Date From ' + @strTableName + ' '
			Set @strSql = @strSql + ' Where ' + @strQry + @strQry2
			Set @strSql = @strSql + ' Mc_User_Id = @userId And Mc_Domain = @domain And Mc_Is_Read = 0 Order By Mc_Receive_Date Desc'
			Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255), @receiveDate datetime OUTPUT'
			
			exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain, @receiveDate = @dReceiveDate OUTPUT
		End
		Else
		Begin
			Set @strSql = 'Select Top ' + Convert(varchar(10), @iCount) + ' @receiveDate = Mc_Receive_Date From '
			Set @strSql = @strSql + ' ' + @strTableName + ' '
			Set @strSql = @strSql + ' Where ' + @strQry + @strQry2
			Set @strSql = @strSql + ' Mc_User_Id = @userId And Mc_Domain = @domain And Mc_Is_Read = 0 Order By Mc_Receive_Date Desc'
			Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255), @receiveDate datetime OUTPUT'
			
			exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain, @receiveDate = @dReceiveDate OUTPUT
		End

		Set @strSql = 'Select Top ' + Convert(varchar(10), @iPageSize) + ' * '
		Set @strSql = @strSql + ' From (Select Top ' + Convert(varchar(10), @iPageSize) + ' * From ' + @strTableName + ' '
		Set @strSql = @strSql + ' Where ' + @strQry + ' Mc_Receive_Date <= @receiveDate And ' +@strQry2+ ' Mc_User_Id = @userId And Mc_Domain = @domain And Mc_Is_Read = 0 Order By Mc_Receive_Date Desc) As Mail_Content '
		Set @strSql = @strSql + ' Order By Mc_Receive_Date Desc'
		Set @param = '@receiveDate datetime, @mailbox smallInt, @userId varchar(30), @domain varchar(255)'
		
		exec sp_executeSql @strSql, @param, @receiveDate = @dReceiveDate, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain
	End
	Else
	Begin
		Set @strSql = 'Select * From ' + @strTableName + ' '
		Set @strSql = @strSql + ' Where '  + @strQry + @strQry2 + '  Mc_User_Id = @userId And Mc_Domain = @domain And Mc_Is_Read = 0 Order By Mc_Receive_Date Desc'
		Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255)'
		
		exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain
	End
End
Else
Begin
	If @iCount <= @iTotalCount And @iPageSize > 0
	Begin	
		If @iPage = 1
		Begin
			Set @strSql = 'Select Top 1 @receiveDate = Mc_Receive_Date From ' + @strTableName + ' '
			Set @strSql = @strSql + ' Where ' + @strQry + @strQry2
			Set @strSql = @strSql + ' Mc_User_Id = @userId And Mc_Domain = @domain Order By Mc_Receive_Date Desc'
			Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255), @receiveDate datetime OUTPUT'
			
			exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain, @receiveDate = @dReceiveDate OUTPUT
		End
		Else
		Begin
			Set @strSql = 'Select Top ' + Convert(varchar(10), @iCount) + ' @receiveDate = Mc_Receive_Date From '
			Set @strSql = @strSql + ' ' + @strTableName + ' '
			Set @strSql = @strSql + ' Where ' + @strQry + @strQry2
			Set @strSql = @strSql + ' Mc_User_Id = @userId And Mc_Domain = @domain Order By Mc_Receive_Date Desc'
			Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255), @receiveDate datetime OUTPUT'
			
			exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain, @receiveDate = @dReceiveDate OUTPUT
		End

		Set @strSql = 'Select Top ' + Convert(varchar(10), @iPageSize) + ' * '
		Set @strSql = @strSql + ' From (Select Top ' + Convert(varchar(10), @iPageSize) + ' * From ' + @strTableName + ' '
		Set @strSql = @strSql + ' Where ' + @strQry + ' Mc_Receive_Date <= @receiveDate And ' +@strQry2+ ' Mc_User_Id = @userId And Mc_Domain = @domain Order By Mc_Receive_Date Desc) As Mail_Content '
		Set @strSql = @strSql + ' Order By Mc_Receive_Date Desc'
		Set @param = '@receiveDate datetime, @mailbox smallInt, @userId varchar(30), @domain varchar(255)'
		
		exec sp_executeSql @strSql, @param, @receiveDate = @dReceiveDate, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain
	End
	Else
	Begin
		Set @strSql = 'Select * From ' + @strTableName + ' '
		Set @strSql = @strSql + ' Where '  + @strQry + @strQry2 + ' Mc_User_Id = @userId And Mc_Domain = @domain Order By Mc_Receive_Date Desc'
		Set @param = '@mailbox smallInt, @userId varchar(30), @domain varchar(255)'
		
		exec sp_executeSql @strSql, @param, @mailbox = @iMailboxIdx, @userId = @strUserId, @domain = @strDomain
	End
End

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO

CREATE Procedure prUpdateMRead
(
	@strUserId varchar(30),
	@strDomain varchar(255),
	@strIdx int,	
	@iMailboxIdx smallInt,
	@strRead int
	
)
As
Declare @strDomainNo char(4),
		@strTableNo char(4),
		@strTableName char(30),
		@strSql nvarchar(1200),
		@param nvarchar(400),
		@iReadCount int


-- ȣ
Select @strDomainNo = Ndl_Idx From Nm_Domain_List Where Ndl_Domain = @strDomain
--̺ ȣ
Select @strTableNo = Nm_Tbl_No From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain
--  ̺ 
Set @strTableName = 'Nm_Mail_Content_' + RTrim(Cast(@strDomainNo As varchar(4))) + '_' + RTrim(Cast(@strTableNo As varchar(4)))

--   Ʈ
Set @strSql = 'Update ' + @strTableName + ' Set '
If @strRead = 1
Begin
	Set @strSql = @strSql + ' Mc_Is_Read = @Read ,'
	Set @strSql = @strSql + ' Mc_Read_Date = GetDate() '
End
Else
Begin
	Set @strSql = @strSql + ' Mc_Is_Read = @Read '
End

Set @strSql = @strSql + ' Where '
Set @strSql = @strSql + ' Mc_Idx = @Idx And Mc_User_id = @userId And Mc_Domain = @domain'
Set @param = '@Idx int, @UserId varchar(30), @domain varchar(255), @Read int'

Exec sp_executeSql @strSql, @param, @Idx = @strIdx, @UserId = @strUserId, @Domain = @strDomain ,@Read=@strRead


--Ϲڽ  ϰ Ʈ


Select @iReadCount = M_No_Read_Count From Nm_Mail_Box Where M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain

If @strRead = 0
Begin	
	Update Nm_Mail_Box Set 
		M_No_Read_Count = M_No_Read_Count + 1
	Where
		M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain
End
Else
Begin
	If @iReadCount > 0
	Begin
		Update Nm_Mail_Box Set 
			M_No_Read_Count = M_No_Read_Count - 1
		Where
			M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain
	End
End	


If @@ERROR <> 0
	Return @@ERROR

Return 0

GO

