﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailReject_ListRejectEmail : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbCommand Cmd = new OleDbCommand();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;
    private JavaScript JS;
    private int iPage = 0;
    private int iPageSize = 15;

    //2010.03.09 검색 기능을 위해서 추가함,
    private string strsch = "";
    protected string TotalCount = "※ 전체 0건";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";

        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);
        WF = new WebFunction();

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        //2010.03.09 검색 기능을 위해서 추가함,
        strsch = WF.StringDefaultValue(Request.Params["schValue"],"").Trim();

        
        if (!Page.IsPostBack)
            this.RejectEmailDataBind();

        // 수신거부 메일주소 등록버튼 속성 추가
        strScript = "if (!CheckRejectEmail()) return false; else return true;";
        ibAddRejectEmail.Attributes.Add("onclick", strScript);

        strScript = "if (keydown()) return;";
        tbRejectEmail.Attributes.Add("onkeydown", strScript);
        // 수신거부 메일주소 삭제버튼 속성 추가
        strScript = "if (!SelectItem()) return false; else return true";
        ibDelRejectEmail.Attributes.Add("onclick", strScript);
    }

    #region 수신거부 메일주소 리스트 바인드
    /// <summary>
    /// 수신거부 메일주소 리스트 바인드
    /// </summary>
    private void RejectEmailDataBind()
    {
        string strMovePage = "";
        int iTotCnt = 0;
        int iTotPage = 1;

        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListRejectEmailAddr";

            Cmd.Parameters.Clear();

            // 현재 페이지
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 출력할 게시물 수
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            //2010.03.09 검색 기능을 위해서 추가함,
            // 검색 명
            sParams = Cmd.Parameters.Add("@varsch", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            //2010.03.09 검색 기능을 위해서 추가함,
            Cmd.Parameters["@varsch"].Value = strsch;
            

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "USERSPAMMER");


            //2010.02.09 수신거부 메일에 <  가 있으면 html에서 제대로 출력 안되는 부분 수정함.
            //추가
            dt = ds.Tables["USERSPAMMER"];

            int iRowCnt = dt.Rows.Count;
            string[,] arrGroupInfo = new string[iRowCnt, 1];

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                arrGroupInfo[iLoop, 0] = dt.Rows[iLoop]["Nre_Email"].ToString();
            }

            dt.Clear();

            dt.Columns.Add("Nre_Email_Value", System.Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                dr["Nre_Email"] = arrGroupInfo[iLoop, 0];
                dr["Nre_Email_Value"] = arrGroupInfo[iLoop, 0].Replace("<", "&lt");
                dt.Rows.Add(dr);
            }

            //끝

            rptRejectEmail.DataSource = ds.Tables["USERSPAMMER"];

            rptRejectEmail.DataBind();

            iTotCnt = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            TotalCount = "※ 전체 " + iTotCnt + "건";

            iTotPage = iTotCnt / 15;

            if ((iTotCnt % 15) > 0)
                iTotPage++;
        }
        catch (Exception err)
        {
            JS.MessageBox("수신거부 리스트를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        //2010.03.09 수정
        //원본
        //lblPageLink.Text = WF.PageLink(iTotPage, iPage, "ListRejectEmail.aspx", "", iPageSize, "", "", "", "");
        lblPageLink.Text = WF.PageLink(iTotPage, iPage, "ListRejectEmail.aspx", "&schValue=" + strsch + "", iPageSize, "", "", "", "");
    }
    #endregion

    #region 수신거부 메일주소 등록
    /// <summary>
    /// 수신거부 메일주소 등록
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddRejectEmail_Click(object sender, ImageClickEventArgs e)
    {
        string strRejectEmail = tbRejectEmail.Text;
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbParameter sParams = new OleDbParameter();
        OleDbCommand Cmd = new OleDbCommand();

        if (strRejectEmail.ToLower() == strUserId.ToLower() + "@" + strDomain.ToLower())
        {
            JS.MessageBox("자신의 메일 주소는 등록할 수 없습니다.");
            JS.HistoryBack();
            return;
        }

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.MovePage("ListRejectEmail.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertRejectEmail";

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Reject Email Address)
            sParams = Cmd.Parameters.Add("@varRejectEmail", OleDbType.VarChar, strRejectEmail.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            // Command Parameter Value Setting
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varRejectEmail"].Value = strRejectEmail;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                JS.MessageBox("스팸 메일 주소를 등록하는 도중 오류가 발생했습니다.\r\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                JS.MovePage("ListRejectEmail.aspx");
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                JS.MessageBox("스팸 메일 주소를 등록하는 도중 오류가 발생했습니다.\r\n" +
                    "SQL Error Number: " + iValue.ToString());
                JS.MovePage("ListRejectEmail.aspx");
                return;
            }
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            JS.MessageBox(strRejectEmail + " 메일주소를 수신거부에 등록하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("ListRejectEmail.aspx");
            return;
        }
        finally
        {
            Trans.Commit();
            Con.Close();
        }

        JS.MovePage("ListRejectEmail.aspx");
    }
    #endregion

    #region 수신거부 메일주소 삭제
    /// <summary>
    /// 수신거부 메일주소 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelRejectEmail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strRejectEmail = hidRejectEmail.Value;
        string[] arrRejectEmail;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.MovePage("ListRejectEmail.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteRejectEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Spam Email Address)
            sParams = Cmd.Parameters.Add("@varRejectEmail", OleDbType.VarWChar, 1000);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 1100);
            sParams.Direction = ParameterDirection.Output;

            if (strRejectEmail.EndsWith("|"))
                strRejectEmail = strRejectEmail.Substring(0, strRejectEmail.Length - 1);

            arrRejectEmail = strRejectEmail.Split('|');

            for (int iLoop = 0; iLoop < arrRejectEmail.Length; iLoop++)
            {
                // Command Parameter Value Setting
                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = strDomain;
                Cmd.Parameters["@varRejectEmail"].Value = arrRejectEmail[iLoop];

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("스팸 메일 주소를 삭제하는 도중 오류가 발생했습니다.\r\n" +
                        "오류 메일 주소: " + strRejectEmail + "\r\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                    Response.Redirect("ListRejectEmail.aspx");
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("스팸 메일 주소를 삭제하는 도중 오류가 발생했습니다.\r\n" +
                        "오류 메일 주소: " + strRejectEmail + "\r\n" +
                        "SQL Error Number: " + iValue.ToString());
                    JS.MovePage("ListRejectEmail.aspx");
                    return;
                }
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            if (Con.State != ConnectionState.Closed)
            {
                Trans.Rollback();
                Con.Close();
            }

            JS.MessageBox("선택한 수신거부 메일주소를 삭제하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("ListRejectEmail.aspx");
            return;
        }

        Con.Close();

        JS.MovePage("ListRejectEmail.aspx");
    }
    #endregion
}
