﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.POP3;

public partial class Config_POP3_ListPop3Info : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private JavaScript JS;
    private UserInfo UI;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        UI = new UserInfo(strUserId, strDomain, strCon);

        //if (!Page.IsPostBack)
        //{
            this.Pop3InfoDataBind();
            this.MailBoxDataBind();
        //}

        string strScript = "if (!AddPop3()) return false; else return true;";
        ibAddPop3Info.Attributes.Add("onclick", strScript);
    }

    #region POP3 정보 데이터 바인드
    /// <summary>
    /// POP3 계정 정보 데이터를 바인드 한다.
    /// </summary>
    private void Pop3InfoDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_POP3");

            if (ds.Tables.Count > 0)
            {
                dt = ds.Tables["MAIL_POP3"];

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue != 0)
                {
                    Con.Close();
                    JS.MessageBox("POP3 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                        "SQL Error Number: " + iValue.ToString());
                    JS.MovePage("../Config.aspx");
                    return;
                }

                int iRowCnt = dt.Rows.Count;
                string[,] arrPop3Info = new string[iRowCnt, 6];

                for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
                {
                    arrPop3Info[iLoop, 0] = dt.Rows[iLoop]["POP3_NO"].ToString();
                    arrPop3Info[iLoop, 1] = dt.Rows[iLoop]["POP3_SERVER"].ToString();
                    arrPop3Info[iLoop, 2] = dt.Rows[iLoop]["POP3_USER_ID"].ToString();
                    arrPop3Info[iLoop, 3] = dt.Rows[iLoop]["POP3_USER_PWD"].ToString();
                    arrPop3Info[iLoop, 4] = dt.Rows[iLoop]["POP3_IS_DEL"].ToString();
                    arrPop3Info[iLoop, 5] = dt.Rows[iLoop]["M_MAILBOX_NAME"].ToString();

                    switch (arrPop3Info[iLoop, 5].ToLower())
                    {
                        case "1":
                            arrPop3Info[iLoop, 5] = "받은편지함";
                            break;
                        case "101":
                            arrPop3Info[iLoop, 5] = "보낸편지함";
                            break;
                        case "201":
                            arrPop3Info[iLoop, 5] = "지운편지함";
                            break;
                        case "301":
                            arrPop3Info[iLoop, 5] = "임시저장함";
                            break;
                        case "401":
                            arrPop3Info[iLoop, 5] = "스팸편지함";
                            break;
                    }
                }

                dt.Rows.Clear();

                for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
                {
                    if (arrPop3Info[iLoop, 4] == "N")
                        arrPop3Info[iLoop, 4] = "사본저장";
                    else
                        arrPop3Info[iLoop, 4] = "사본삭제";

                    DataRow dr = dt.NewRow();
                    dr["POP3_NO"] = int.Parse(arrPop3Info[iLoop, 0]);
                    dr["POP3_SERVER"] = arrPop3Info[iLoop, 1];
                    dr["POP3_USER_ID"] = arrPop3Info[iLoop, 2];
                    dr["POP3_USER_PWD"] = arrPop3Info[iLoop, 3];
                    dr["POP3_IS_DEL"] = arrPop3Info[iLoop, 4];
                    dr["M_MAILBOX_NAME"] = arrPop3Info[iLoop, 5];
                    dt.Rows.Add(dr);
                }
            }
            rptPop3Info.DataSource = dt.DefaultView;
            rptPop3Info.DataBind();
        }
        catch (Exception err)
        {
            JS.MessageBox("POP3 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                "오류 내용: " + err.Message);
            JS.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 개인 편지함 데이터 바인드
    /// <summary>
    /// 개인 편지함 DropDownList 컨트롤에 데이터를 바인드 한다.
    /// </summary>
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsDefault", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsMainView", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@strIsDefault"].Value = "";
            Cmd.Parameters["@strIsMainView"].Value = "";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Con.Close();
                JS.MessageBox("POP3 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                    "SQL Error Number: " + iValue.ToString());
                JS.MovePage("../Config.aspx");
                return;
            }

            int iRowCount = dt.Rows.Count;
            int iCount = 0;
            string[,] arrMailbox = new string[iRowCount, 2];

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_IDX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                ListItem li = new ListItem(arrMailbox[iLoop, 1], arrMailbox[iLoop, 0]);
                ddlSaveBox.Items.Add(li);
            }
            ddlSaveBox.DataBind();
        }
        catch (Exception err)
        {
            JS.MessageBox("편지함 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region POP3 정보 추가
	/// <summary>
	/// POP3 정보를 DB에 추가한다.
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	protected void ibAddPop3Info_Click(object sender, System.Web.UI.ImageClickEventArgs e)
	{
		string strPop3ServerName = tbPop3ServerName.Text;
		string strPop3UserId = tbPop3UserId.Text;
		string strPop3UserPwd = tbPop3UserPwd.Value;
		string strPop3IsDel = rblPop3IsDel.SelectedValue;
		string strPop3Savebox = "";
        string strMailboxIdx = "";
		bool bChecked = chkIsNewSaveBox.Checked;

		int iValue = 0;

		if (!bChecked)
			strPop3Savebox = ddlSaveBox.SelectedValue;
		else
			strPop3Savebox = tbNewSaveBox.Text;
		
		try
		{
			Con = new OleDbConnection(strCon);
			Con.Open();
			Trans = Con.BeginTransaction();
		} 
		catch (Exception err)
		{
			JS.MessageBox("DB Connection Fail!!!\r\n" +
				err.Message);
			JS.MovePage("ListPop3Info.aspx");
			return;
		}
		
		try
		{
			Cmd.Connection = Con;
			Cmd.Transaction = Trans;
			Cmd.CommandType = CommandType.StoredProcedure;
			
            // 새편지함 생성일 경우에 편지함을 개인 편지함에 등록하고 폴더를 새로 생성한다.
            if (bChecked)
            {
                Cmd.Parameters.Clear();
                Cmd.CommandText = "prInsertMailbox";

                // Command Parameter (Execute Return Value)
                Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                // Command Parameter (User Id)
                Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                // Command Parameter (Domain)
                Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                // Command Parameter (Mailbox Name)
                Param = Cmd.Parameters.Add("@varMailboxName", OleDbType.VarWChar, strPop3Savebox.Length);
                Param.Direction = ParameterDirection.Input;

                // Command Paramter (Is Default)
                Param = Cmd.Parameters.Add("@strIsDefault", OleDbType.Char, 1);
                Param.Direction = ParameterDirection.Input;

                // Command Parameter (Output Value)
                Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
                Param.Direction = ParameterDirection.Output;

                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = strDomain;
                Cmd.Parameters["@varMailboxName"].Value = strPop3Savebox;
                Cmd.Parameters["@strIsDefault"].Value = "N";

                Cmd.ExecuteNonQuery();

                iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    JS.MessageBox(strPop3Savebox + " 편지함을 등록하는 도중 오류가 발생했습니다.\r\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                    JS.MovePage("ListPOP3Info.aspx");
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    JS.MessageBox(strPop3Savebox + " 편지함을 등록하는 도중 오류가 발생했습니다.\r\n" +
                        "SQL Error Number: " + iValue.ToString());
                    JS.MovePage("ListPOP3Info.aspx");
                    return;
                }

                strMailboxIdx = Cmd.Parameters["@varRtnVal"].Value.ToString();
            }
            else
                strMailboxIdx = strPop3Savebox;

            Cmd.CommandText = "prInsertPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (User Id)
			Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Domain)
			Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server Name or Address)
			Param = Cmd.Parameters.Add("@varPop3Server", OleDbType.VarChar, strPop3ServerName.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server User Id)
			Param = Cmd.Parameters.Add("@varPop3UserId", OleDbType.VarChar, strPop3UserId.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server User Password)
			Param = Cmd.Parameters.Add("@varPop3UserPwd", OleDbType.VarChar, strPop3UserPwd.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server Mail Is Delete)
			Param = Cmd.Parameters.Add("@chrPop3IsDel", OleDbType.Char, 1);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server Mail Save Mailbox)
			Param = Cmd.Parameters.Add("@iPop3SaveboxIdx", OleDbType.SmallInt);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Output Value)
			Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 600);
			Param.Direction = ParameterDirection.Output;

			// Command Parameter Value Setting
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;
			Cmd.Parameters["@varPop3Server"].Value = strPop3ServerName;
			Cmd.Parameters["@varPop3UserId"].Value = strPop3UserId;
			Cmd.Parameters["@varPop3UserPwd"].Value = strPop3UserPwd;
			Cmd.Parameters["@chrPop3IsDel"].Value = strPop3IsDel;
            Cmd.Parameters["@iPop3SaveboxIdx"].Value = int.Parse(strMailboxIdx);

			// Execute
			Cmd.ExecuteNonQuery();

			iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Trans.Rollback();
				JS.MessageBox("POP3 정보를 등록하는 도중 오류가 발생했습니다.\r\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
				JS.MovePage("ListPOP3Info.aspx");
				return;
			} 
			else if (iValue != 0)
			{
				Trans.Rollback();
				JS.MessageBox("POP3 정보를 등록하는 도중 오류가 발생했습니다.\r\n" +
					"오류 POP3 Server: " + strPop3ServerName + "\r\n" +
					"SQL Error Number: " + iValue.ToString());
				JS.MovePage("ListPOP3Info.aspx");
				return;
			}

			
		} 
		catch (Exception err)
		{
			JS.MessageBox(strPop3ServerName + " 서버 POP3 계정을 등록하는 도중 오류가 발생했습니다.\r\n" +
				"오류 내용: " + err.Message);
			JS.MovePage("ListPop3Info.aspx");
			return;
		} 
		finally
		{
			if (bChecked)
			{
				if (!Directory.Exists(UI.UserPath + "\\" + strPop3Savebox))
					Directory.CreateDirectory(UI.UserPath + "\\" + strPop3Savebox);
			}

			Trans.Commit();
			Con.Close();
			Cmd.Parameters.Clear();
			 
		}

		JS.MessageBox(strPop3ServerName + " 서버 POP3 계정이 등록되었습니다.");
		JS.MovePage("ListPop3Info.aspx");
	}
	#endregion

	protected void chkIsNewSaveBox_CheckedChanged(object sender, EventArgs e)
	{
		if (chkIsNewSaveBox.Checked)
		{
			ddlSaveBox.Enabled = false;
			tbNewSaveBox.Enabled = true;
		}
		else
		{
			ddlSaveBox.Enabled = true;
			tbNewSaveBox.Enabled = false;
		}
	}

	#region 개인 외부메일 정보 삭제(POP3)
	/// <summary>
	/// 개인 외부메일 정보 삭제(POP3)
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	protected void ibDelPop3_DelCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
	{
		int iPop3No = int.Parse(e.CommandName);
		
		try
		{
			Con = new OleDbConnection(strCon);
			Con.Open();
			Trans = Con.BeginTransaction();
		}
		catch (Exception err)
		{
			JS.MessageBox("DB Connection Fail!!!\r\n" +
				err.Message);
			JS.MovePage("ListPop3Info.aspx");
			return;
		}
		
		try
		{
			Cmd.Connection = Con;
			Cmd.Transaction = Trans;
			Cmd.CommandType = CommandType.StoredProcedure;
			Cmd.CommandText = "prDeletePop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (Pop3 Info No)
			Param = Cmd.Parameters.Add("@iPop3No", OleDbType.Integer);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (User Id)
			Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			Param.Direction = ParameterDirection.Input;
			
			// Command Parameter (Domain)
			Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			Param.Direction = ParameterDirection.Input;
			
			// Command Parameter (Output Value)
			Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
			Param.Direction = ParameterDirection.Output;
			
			Cmd.Parameters["@iPop3No"].Value = iPop3No;
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;
			
			Cmd.ExecuteNonQuery();

			int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Trans.Rollback();
				Con.Close();
				JS.MessageBox("POP3 정보를 삭제하려는 도중 오류가 발생했습니다.\r\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\\", "\r\n"));
				JS.MovePage("ListPop3Info.aspx");
				return;
			} 
			else if (iValue != 0)
			{
				Trans.Rollback();
				Con.Close();
				JS.MessageBox("POP3 정보를 삭제하려는 도중 오류가 발생했습니다.\r\n" +
					"SQL Error Number: " + iValue.ToString());
				JS.MovePage("ListPop3Info.aspx");
				return;
			}
		} 
		catch (Exception err)
		{
			Trans.Rollback();
			Con.Close();
			JS.MessageBox("POP3 정보를 삭제하는 도중 오류가 발생했습니다.\r\n" +
				"오류 내용: " + err.Message);
			JS.MovePage("ListPop3Info.aspx");
			return;
		} 
		finally
		{
			Trans.Commit();
			Con.Close();
			Cmd.Parameters.Clear();
			 
		}

		JS.MessageBox("POP3정보를 삭제하였습니다.");
		JS.MovePage("ListPop3Info.aspx");
	}
	#endregion

	#region 외부메일 가져오기(POP3)
	/// <summary>
	/// 외부메일 가져오기(POP3)
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	protected void ibReadPop3_ReadCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
	{
		int iPop3No = int.Parse(e.CommandName);
		string strPop3ServerName = "";
		string strPop3UserId = "";
		string strPop3UserPwd = "";
		string strPop3Savebox = "";
		bool bPop3IsDelMail = false;
        bool bSuccess = true;
        string strMsg = "";
        long useSize = 0;
        long templong = 1048576;
        long iMxa = 0;

		try
		{
			Con = new OleDbConnection(strCon);
			Con.Open();
		}
		catch (Exception err)
		{
			JS.MessageBox("DB Connection Fail!!!\r\n" +
				err.Message);
			JS.MovePage("ListPop3Info.aspx");
			return;
		}

		try
		{
			Cmd.Connection = Con;
			Cmd.CommandType = CommandType.StoredProcedure;
			Cmd.CommandText = "prSelectPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (Pop3 Info No)
			Param = Cmd.Parameters.Add("@iPop3No", OleDbType.Integer);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (User Id)
			Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Domain)
			Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			Param.Direction = ParameterDirection.Input;

			// Command Parameter (Output Value)
			Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
			Param.Direction = ParameterDirection.Output;

			Cmd.Parameters["@iPop3No"].Value = iPop3No;
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;

			Adap = new OleDbDataAdapter(Cmd);
			Adap.Fill(ds, "MAIL_POP3_INFO");
            dt = ds.Tables["MAIL_POP3_INFO"];

			int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Con.Close();
				JS.MessageBox("POP3 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\\", "\r\n"));
				JS.MovePage("ListPop3Info.aspx");
				return;
			} 
			else if (iValue != 0)
			{
				Con.Close();
				JS.MessageBox("POP3 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
					"SQL Error Number: " + iValue.ToString());
				JS.MovePage("ListPop3Info.aspx");
				return;
			}

			int iRowCnt = dt.Rows.Count;

			if (iRowCnt == 1)
			{
				strPop3ServerName = dt.Rows[0]["POP3_SERVER"].ToString();
				strPop3UserId = dt.Rows[0]["POP3_USER_ID"].ToString();
				strPop3UserPwd = dt.Rows[0]["POP3_USER_PWD"].ToString();
				strPop3Savebox = dt.Rows[0]["POP3_SAVEBOX_IDX"].ToString();
				
				if (dt.Rows[0]["POP3_IS_DEL"].ToString() == "Y")
					bPop3IsDelMail = true;
			}
			else if (iRowCnt < 1) 
			{
				JS.MessageBox("읽어오려는 POP3 정보가 없습니다.");
				JS.MovePage("ListPop3Info.aspx");
				return;
			}
			else if (iRowCnt > 1)
			{
				JS.MessageBox("동일한 POP3 정보가 존재합니다.\r\nPOP3정보를 확인해 주세요.");
				JS.MovePage("ListPop3Info.aspx");
				return;
			}
		}
		catch (Exception err)
		{
			JS.MessageBox("POP3 정보를 읽어오는 도중 오류가 발생했습니다.\r\n" +
				"오류 내용: " + err.Message);
			JS.MovePage("ListPop3Info.aspx");
			return;
		} 
		finally
		{
			Con.Close();
			Cmd.Parameters.Clear();
			 
		}

        JS.LodingPage("외부메일(POP3)을 가져오고 있습니다.");

		POP3Client pop = new POP3Client();

		try
		{
            if (!Directory.Exists(UI.UserPath + "\\pop3"))
                Directory.CreateDirectory(UI.UserPath + "\\pop3");
            
			pop.POP3Read(strPop3ServerName, strPop3UserId, strPop3UserPwd, UI.UserPath + "\\pop3", UI.UserMailBoxSize, bPop3IsDelMail);
		} 
		catch (POP3Exception err)
		{
			JS.MessageBox("POP3에 접속해서 메일을 가져오는 도중 오류가 발생했습니다.\r\n" +
				"오류 내용: " + err.Message.Replace("\r\n","\r\n"));
			JS.MovePage("ListPop3Info.aspx");
			return;
		}

        try
        {
            Passkorea.DbMail.DbMail dbMail = new Passkorea.DbMail.DbMail();

            DirectoryInfo dir = new DirectoryInfo(UI.UserPath + "\\pop3");

            useSize = UI.GetUseMailSize();

            iMxa = UI.UserMailBoxSize * templong;

            foreach (FileInfo file in dir.GetFiles())
            {
                useSize += file.Length;

                //if ((UI.UserMailBoxSize * 1048576) > useSize)
                if (iMxa > useSize)
                {
                    dbMail.DbCon = strCon;
                    dbMail.UserId = strUserId;
                    dbMail.Domain = strDomain;
                    dbMail.MailboxIdx = int.Parse(strPop3Savebox);
                    dbMail.MailFilePath = file.FullName;

                    if (dbMail.InsertDbMail())
                    {
                        if (!Directory.Exists(dbMail.MoveMailBox))
                            Directory.CreateDirectory(dbMail.MoveMailBox);

                        File.Move(file.FullName, dbMail.MoveMailBox + "\\" + dbMail.MoveMailFile);
                    }
                    else
                    {
                        if (!dbMail.ExistsMail)
                        {
                            if (!Directory.Exists(UI.UserPath + "\\Error"))
                                Directory.CreateDirectory(UI.UserPath + "\\Error");

                            File.Move(file.FullName, UI.UserPath + "\\Error\\" + file.Name);

                            if (!File.Exists(UI.UserPath + "\\Error\\ReportErrorMail.txt"))
                                File.Create(UI.UserPath + "\\Error\\ReportErrorMail.txt").Close();

                            FileStream fs = new FileStream(UI.UserPath + "\\Error\\ReportErrorMail.txt", FileMode.Append, FileAccess.Write);
                            StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);

                            strMsg = "[" + DateTime.Now.ToString() + "]\t" + file.Name + "\t" + dbMail.ErrorMessage + "\r\n\r\n";

                            sw.Write(strMsg);
                            sw.Close();
                            fs.Close();
                        }
                        else
                            File.Delete(file.FullName);
                    }
                }
                else
                {
                    if (!Directory.Exists(UI.UserPath + "\\Error"))
                        Directory.CreateDirectory(UI.UserPath + "\\Error");

                    if (!File.Exists(UI.UserPath + "\\Error\\ReportErrorMail.txt"))
                        File.Create(UI.UserPath + "\\Error\\ReportErrorMail.txt").Close();

                    FileStream fs = new FileStream(UI.UserPath + "\\Error\\ReportErrorMail.txt", FileMode.Append, FileAccess.Write);
                    StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);

                    strMsg = "[" + DateTime.Now.ToString() + "]\tallow size limit!\tallow size: " + UI.UserMailBoxSize.ToString() + " MB\tUse Size: " + useSize.ToString() + " Byte\r\n\r\n";

                    sw.Write(strMsg);
                    sw.Close();
                    fs.Close();

                    bSuccess = false;

                    break;
                }
            }

            dir.Delete(false);
        }
        catch (Exception err)
        {
            JS.MessageBox(err.Message);
            JS.HistoryBack();
            return;
        }
        finally
        {

        }

        JS.EndLodingPage();

        if (bSuccess)
		    JS.MessageBox("메일을 정상적으로 가져왔습니다.");
        else
            JS.MessageBox("제한용량인 " + UI.UserMailBoxSize.ToString() + " MB를 초과하여 더이상 외부메일을 가져올 수 없습니다.");

		JS.MovePage("../../Mail/ListMail.aspx?mailbox=" + strPop3Savebox);
	}
	#endregion
}
