﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Confirm_ListConfirm : System.Web.UI.Page
{
    protected System.Web.UI.WebControls.Label lblMsg;

    private UserInfo UI;
    private JavaScript JS;
    private WebFunction WF;
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strRecId = "";
    private int iPage = 0;
    private int iPageSize = 15;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);
        WF = new WebFunction();

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        UI = new UserInfo(strUserId, strDomain, strCon);

        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        if (!Page.IsPostBack)
        {
            this.ConfirmDataBind();
        }

        strScript = "if (!delConfirm()) return false; else return true;";
        ibDelConfirm.Attributes.Add("onclick", strScript);
    }

    #region 수신확인 데이터 바인드
    /// <summary>
    /// 수신확인 데이터를 바인드 한다.
    /// </summary>
    private void ConfirmDataBind()
    {
        string strMovePage = "";
        int iValue = 0;
        int iTotPage = 0;
        int iCount = 0;

        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailConfirm";

            // Command Parameter (This Page)
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (This List Count)
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Record Total Count)
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_CONFIRM");
            dt = ds.Tables["MAIL_CONFIRM"];

            iValue = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            int iRowCount = dt.Rows.Count;
            string[,] confirmData = new string[iRowCount, 10];

            foreach (DataRow dr in dt.Rows)
            {
                confirmData[iCount, 0] = dr["SEND_MAIL_ID"].ToString();
                confirmData[iCount, 1] = dr["SAVE_MAIL_ID"].ToString();
                confirmData[iCount, 2] = dr["MAIL_TYPE"].ToString();
                confirmData[iCount, 3] = dr["RECEIVE_EMAIL"].ToString();
                confirmData[iCount, 4] = dr["SEND_DATE"].ToString();
                confirmData[iCount, 5] = dr["IS_READ"].ToString();
                confirmData[iCount, 6] = dr["READ_DATE"].ToString();
                confirmData[iCount, 7] = dr["MAIL_SUBJECT"].ToString();
                confirmData[iCount, 8] = dr["IS_LOCAL"].ToString();
                confirmData[iCount, 9] = dr["Mc_Idx"].ToString();

                iCount++;
            }

            dt.Clear();

            dt.Columns.Remove("READ_DATE");
            dt.Columns.Remove("SEND_DATE");

            dt.Columns.Add("READ_DATE", System.Type.GetType("System.String"));
            dt.Columns.Add("SEND_DATE", System.Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                DataRow dr = dt.NewRow();
                // 메일 제목이 있는지 없는지 확인
                if (confirmData[iLoop, 7] != null)
                {
                    if (confirmData[iLoop, 7] == "")
                        confirmData[iLoop, 7] = "제목이 없습니다.";
                    else
                    {
                        if (confirmData[iLoop, 7].Length > 20)
                            confirmData[iLoop, 7] = confirmData[iLoop, 7].Substring(0, 20) + "...";
                    }
                }
                else
                    confirmData[iLoop, 7] = "제목이 없습니다.";

                // 메일이 보낸 편지함에 있는지 확인
                if (confirmData[iLoop, 9] != "")
                {
                    dr["Mc_Idx"] = confirmData[iLoop, 9];
                
                    // 메일이 있다면 파싱해서 제목을 보여준다.
                    dr["MAIL_SUBJECT"] = "<a href=\"../Mail/viewMail.aspx?MailBox=101&mailId=" + confirmData[iLoop, 9] + "&iPage=" + iPage + "\">" + confirmData[iLoop, 7] + "</a>";
                }
                else
                {
                    // 메일이 없다면 메일이 없다고 보여준다.
                    dr["MAIL_SUBJECT"] = confirmData[iLoop, 7];
                }

                // 메일을 읽었는지 안읽었는지 표시를 해준다.
                if (confirmData[iLoop, 5] == "0")
                {
                    dr["IS_READ"] = "<b>읽지않음</b>";

                    if (confirmData[iLoop, 6] != "")
                        dr["READ_DATE"] = confirmData[iLoop, 6];
                    else
                        dr["READ_DATE"] = "-";
                }
                else if (confirmData[iLoop, 5].ToLower() == "1")
                {
                    dr["IS_READ"] = "<b><font color=\"blue\">읽음</font></b>";
                    dr["READ_DATE"] = confirmData[iLoop, 6];
                }
                else if (confirmData[iLoop, 5] == "2")
                {
                    dr["IS_READ"] = "<b><font color=\"red\">발송취소</font></b>";
                    dr["READ_DATE"] = "-";
                }
                else
                {
                    dr["IS_READ"] = "읽지않음";
                    dr["READ_DATE"] = "-";
                }

                dr["SEND_MAIL_ID"] = confirmData[iLoop, 0];
                dr["SAVE_MAIL_ID"] = confirmData[iLoop, 1];

                // 2006년 11월 24일 수정
                // 받는 사람 메일주소값이 string 배열로 넘어 오기 때문에 DataRow에 바로 넣으면 System.String[]으로 출력되어서
                //	string 배열 변수에 담아서 처리
                string[] strMailAddr = WF.linkMailAddress(confirmData[iLoop, 3], "../Mail/writeMail.aspx?email=", 10, "...");
                dr["RECEIVE_EMAIL"] = strMailAddr[0];
                dr["SEND_DATE"] = confirmData[iLoop, 4];

                // 2007년 12월 11일 추가
                // 메일 회수기능 버튼
                dr["IS_LOCAL"] = confirmData[iLoop, 8] + "/" + confirmData[iLoop, 5];

                dt.Rows.Add(dr);
            }

            iTotPage = iValue / 15;

            if ((iTotPage % 15) > 0)
                ++iTotPage;
        }
        catch (Exception err)
        {
            JS.MessageBox("수신확인 데이터를 가져오는 도중 오류가 발생했습니다.\r\n" +
                "서버 관리자에게 문의하세요.\r\n" + err.Message);
        }

        rptConfirm.DataSource = dt.DefaultView;
        rptConfirm.DataBind();
        lblPageLink.Text = WF.PageLink(iTotPage, iPage, strMovePage, "", 10, "", "", "", "");
    }
    #endregion

    #region 수신확인 삭제 버튼 클릭
    /// <summary>
    /// 수신확인 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelConfirm_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strConfirmId = hidSendMailId.Value;
        string[] arrConfirmId;
        string strSql = "";

        if (strConfirmId == "")
        {
            JS.MessageBox("삭제할 수신확인 항목을 선택해 주세요.");
            JS.MovePage("ListConfirm.aspx");
            return;
        }

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();

        Con.Open();
        OleDbTransaction Trans = Con.BeginTransaction();
        Cmd.Connection = Con;
        Cmd.Transaction = Trans;

        if (strConfirmId.EndsWith("│"))
            strConfirmId = strConfirmId.Substring(0, strConfirmId.Length - 1);
        
        arrConfirmId = strConfirmId.Split('│');
        strConfirmId = "";

        for (int iLoop = 0; iLoop < arrConfirmId.Length; iLoop++)
        {
            strConfirmId += "'" + arrConfirmId[iLoop] + "',";
        }

        if (strConfirmId != "")
        {
            if (strConfirmId.EndsWith(","))
                strConfirmId = strConfirmId.Substring(0, strConfirmId.Length - 1);

            strSql = "DELETE FROM MAIL_CONFIRM WHERE SEND_MAIL_ID IN (" + strConfirmId + ") AND USER_ID = '" + Session["USER_ID"].ToString() + "' " +
                "AND USER_DOMAIN = '" + strDomain + "'";

            try
            {
                Cmd.CommandText = strSql;
                Cmd.ExecuteNonQuery();

                Trans.Commit();
            }
            catch (Exception err)
            {
                Con.Close();

                JS.MessageBox("선택한 수신확인 정보를 삭제하는 도중 오류가 발생했습니다.\r\n" +
                    err.Message);
                JS.HistoryBack();
            }
            finally
            {
                Con.Close();
            }

            for (int iLoop = 0; iLoop < arrConfirmId.Length; iLoop++)
            {
                if (arrConfirmId[iLoop].Trim() != "")
                {
                    if (File.Exists(UI.UserPath + "\\outbox\\" + WF.AddFileName(UI.UserPath + "\\outbox\\" + arrConfirmId[iLoop] + ".eml", 1)))
                        File.Delete(UI.UserPath + "\\outbox\\" + WF.AddFileName(UI.UserPath + "\\outbox\\" + arrConfirmId[iLoop] + ".eml", 1));
                }
            }

            JS.MessageBox("선택한 수신확인 정보를 삭제했습니다.");
            JS.MovePage("ListConfirm.aspx");
        }
    }
    #endregion

    #region 발송취소
    /// <summary>
    /// 발송취소
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnRecallEmail_Command(object sender, CommandEventArgs e)
    {
        string strSendMailId = e.CommandName;
        string strIsLocal = e.CommandArgument.ToString();
        string strUserPath = "";
        //string strLocalUserId = "";
        string strMailboxNo = "";
        string strIsRead = "";
        string strRtnVal = "";

        string strRecId = "";


        if (strSendMailId.Trim() == "")
        {
            JS.MessageBox("발송정보가 없습니다.");
            JS.HistoryBack();
            return;
        }

        if (strIsLocal.Substring(0, 1) != "Y")
        {
            JS.MessageBox("발송취소 하려는 메일은 로컬 도메인으로 보내진 메일이 아닙니다.");
            JS.HistoryBack();
            return;
        }
        else
        {
            if (strIsLocal.Substring(2, 1) != "0")
            {
                JS.MessageBox("발송한 메일이 로컬이 아니거나 읽은 메일이어서 발송취소할 수 없습니다.");
                JS.HistoryBack();
                return;
            }

            strIsLocal = strIsLocal.Substring(0, 1);
        }

        try
        {
            if (Con == null)
                Con = new OleDbConnection(strCon);

            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Parameters.Clear();

            //2010.03.03 추가
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prLoadRecMailConfirm";

            // Command Parameter (Send Mail Id)
            sParams = Cmd.Parameters.Add("@varSendMailId", OleDbType.VarChar, strSendMailId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varSendMailId"].Value = strSendMailId;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            OleDbDataReader dataReader = Cmd.ExecuteReader();

            if (dataReader.HasRows)
            {
                dataReader.Read();
                strRecId = dataReader["RECEIVE_EMAIL"].ToString();

            }

            //09.11.11 추가
            //받는사람을 가져오기 부분을 수정을 했음. 메일주소를 전체 다 가져와서 아이디만 출력함.

            //  " 제거
            strRecId = strRecId.Replace("\"", "");

            // 뒤에서부터 해서 < 있는 위치를 찾음
            int iPos = strRecId.LastIndexOf("<");

            // < 위치를 찾아서 0보다 크거나 같을경우 <위치부터 자름.
            if (iPos >= 0)
                strRecId = strRecId.Substring(iPos + 1);

            // @위치를 찾음
            int iPos2 = strRecId.LastIndexOf("@");

            // @위치가 0이상이면 문자열을 처음부터 @위치까지 자름. ID가 됨.
            // @위치가 없거나 0이면 아이디를 제대로 못찾아 오기 때문에 애러를 뿜음.
            if (iPos2 > 0)
                strRecId = strRecId.Substring(0, iPos2);
            else
            {
                JS.MessageBox("받는사람 아이디 가져 오는작업이 실패 했습니다.");

                JS.HistoryBack();
                return;
            }

            Cmd.Parameters.Clear();
            dataReader.Close();
            //2010.03.03 여기까지.

            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prLoadMailConfirm";

            // Command Parameter (Send Mail Id)
            sParams = Cmd.Parameters.Add("@varSendMailId", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (RecId)
            sParams = Cmd.Parameters.Add("@varRecId", OleDbType.VarChar, strRecId.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varSendMailId"].Value = strSendMailId + ".eml";
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varRecId"].Value = strRecId;

            dataReader = Cmd.ExecuteReader();

            if (dataReader.HasRows)
            {
                dataReader.Read();

                strUserPath = dataReader["User_Mailbox_Path"].ToString();
                strMailboxNo = dataReader["Mc_Mailbox_No"].ToString();
            }

            dataReader.Close();

            Trans = Con.BeginTransaction();

            if (strMailboxNo != "")
            {
                if (File.Exists(strUserPath + "\\" + strMailboxNo + "\\" + strSendMailId + ".eml"))
                    File.Delete(strUserPath + "\\" + strMailboxNo + "\\" + strSendMailId + ".eml");
            }

            Cmd.Parameters.Clear();

            Cmd.Transaction = Trans;
            Cmd.CommandText = "prUpdateMailConfirm";

            // Command Parameter (Execute Result)
            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Send Mail Id)
            sParams = Cmd.Parameters.Add("@varSendMailId", OleDbType.VarChar, strSendMailId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            //09.11.11 받는 사람 추가함.
            // Command Parameter (Receive_Id(받는사람))
            sParams = Cmd.Parameters.Add("@varReceive_Id", OleDbType.VarChar, strRecId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Is Read)
            sParams = Cmd.Parameters.Add("@chrIsRead", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 512);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varSendMailId"].Value = strSendMailId;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varReceive_Id"].Value = strRecId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrIsRead"].Value = "2";

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());
            strRtnVal = Cmd.Parameters["@varRtnVal"].Value.ToString();

            if (iResult == -1)
            {
                Trans.Rollback();
                JS.MessageBox(strRtnVal);
                JS.HistoryBack();
                return;
            }
            else if (iResult != 0)
            {
                Trans.Rollback();
                JS.MessageBox("발송취소하는 도중 오류가 발생하였습니다..\r\n" +
                    "SQL Error No: " + iResult.ToString());
                JS.HistoryBack();
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            if (Trans != null)
                Trans.Rollback();

            JS.MessageBox("발송취소를 하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }

        //2010.03.03 추가 안내문.
        JS.MessageBox("메일이 취소(회수) 되었습니다.\r\n" +
                      "취소후 받는 사람이 메일을 읽을 가능성\r\n" +
                      " 1. 아웃룩 등의 메일클라이언트(POP3)를 통해 다른 곳에 사본이 저장된 경우\r\n" +
                      " 2. 메일 포워딩을 통해 다른 계정으로 재전송해둔 경우\r\n");

        JS.MovePage("ListConfirm.aspx?iPage=" + iPage.ToString());
        return;
    }
    #endregion

    protected void rptConfirm_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        string strScript = "";
        int iItmCnt = e.Item.Controls.Count;
        int i = 0;

        for (i = 0; i < iItmCnt; i++)
        {
            ImageButton iBtn = (ImageButton)e.Item.Controls[i].FindControl("btnRecallEmail");

            if (iBtn != null)
            {
                string strValue = iBtn.CommandArgument.ToString();

                if (strValue.Trim().Substring(0, 1) == "Y" && strValue.Trim().Substring(2, 1) == "0")
                {
                    strScript = "if (!RecallEmail()) return false; else return true;";
                    iBtn.Attributes.Add("onclick", strScript);
                }
                else
                    iBtn.Visible = false;
            }
        }
    }
}
