﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Mail_Main : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private UserInfo UI;
    private WebFunction WF;
    private JavaScript JS;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    protected string strUserId = "";
    protected string strUserName = "";
    protected string strUserEmail = "";
    protected int iNoReadMailCnt = 0;
    protected int iNewMailCnt = 0;
    protected int iMailCnt = 0;
    protected long iUseSize = 0;
    protected double iMaxSize = 0;
    protected double iPer = 0;
    protected double iPerWebhard = 0;
    protected string strAutoReplyMsg = "";
    protected string strForwardingMsg = "";
    protected string strAutoFilteringMsg = "";
    protected string strEmailRejectMsg = "";
    protected string strWebhardSize = "";
    protected string strUseWebhardSize = "";
    protected string strUseSize = "";
    protected int iMailboxCount = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        JS = new JavaScript(this.Page);
		JS.LoginCheck(Session["USER_ID"], "../log/login.aspx", false);
        WF = new WebFunction();

        strDomain = Session["MAIL_DOMAIN"].ToString();
		strUserId = Session["USER_ID"].ToString();
		
		UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            strUserName = UI.UserName;
            strUserEmail = strUserId + "@" + strDomain;
            
            iNoReadMailCnt = 0;
            iNewMailCnt = 0;
            iMailCnt = 0;

            if (iMailCnt < 1) iMailCnt = iNewMailCnt;

            if (UI.UserMailBoxSize > 0)
            {
                iUseSize = UserUseMailBoxSize();
                strUseSize = WF.GetFileSize(iUseSize);
                iMaxSize = Math.Round(Convert.ToDouble(UI.UserMailBoxSize), 2);
                
                iPer = Math.Round(((iUseSize / 1048576)/ iMaxSize) * 100, 2);
            }

            long lUseWebhard = UI.WebhardUseSize();

            if (lUseWebhard > 0)
            {
                iPerWebhard = Math.Round(lUseWebhard / Convert.ToDouble(UI.WebhardAllocateSize * 1048576) * 100, 2);
                if (iPerWebhard > 180)
                    iPerWebhard = 180;
            }
            
            strWebhardSize = WF.GetFileSize(UI.WebhardAllocateSize * 1048576);
            strUseWebhardSize = WF.GetFileSize(lUseWebhard);

            //this.MailListBind(ref rptMailList, ref tblMailList, 1, 10);
            this.MainViewMailBox();
            this.NewBoardDocDataBind();
            this.ScheduleDataBind();
            this.NoteDataBind();
            this.AutoReplyMsg();
            this.AutoFiltering();
            this.EmailReject();
            this.UseForwarding();
            Page.DataBind();
        }

        ibDeleteMail.Attributes.Add("onclick", "if (!(CheckMail(\"삭제\"))) return false; else return true;");
        ibRejectMail.Attributes.Add("onclick", "if (!(CheckMail(\"수신거부\"))) return false; else { if (RejectMail()) return true; else return false; }");
    }

    #region 사용자 메일박스 사용용량 계산
    /// <summary>
    /// 사용자 메일박스 사용용량 계산
    /// </summary>
    /// <returns></returns>
    public long UserUseMailBoxSize()
    {
        long iSize = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return 0;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prMailboxSize";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsDefault", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMailboxIdx"].Value = 0;
            Cmd.Parameters["@strIsDefault"].Value = "";

            OleDbDataReader reader = Cmd.ExecuteReader();
            
            if (reader.HasRows)
            {
                reader.Read();
                
                iMailCnt = int.Parse(reader["M_Mail_Count"].ToString());
                iSize = long.Parse(reader["M_Use_Size"].ToString());
                iNoReadMailCnt = int.Parse(reader["M_No_Read_Count"].ToString());
            }
            
            reader.Close();
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox(e.Message);
            return 0;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
        
        return iSize;
    }
    #endregion

    #region 자동응답 사용여부 확인
    /// <summary>
    /// strEmailRejectMsg
    /// </summary>
    private void AutoReplyMsg()
    {
        if (File.Exists(UI.UserPath + "\\autoreply.htm"))
            strAutoReplyMsg = "<b><font color=#ff0000>사용중</font></b>";
        else
            strAutoReplyMsg = "<font color=\"#0000ff\">사용안함</font>";
    }
    #endregion

    #region 포워딩 사용여부 확인
    /// <summary>
    /// 포워딩 사용여부 확인
    /// </summary>
    private void UseForwarding()
    {
        if (File.Exists(UI.UserPath + "\\forwarding.txt"))
            strForwardingMsg = "<b><font color=#ff0000>사용중</font></b>";
        else
            strForwardingMsg = "<font color=\"#0000ff\">사용안함</font>";
    }
    #endregion

    #region 자동분류 사용여부 확인
    /// <summary>
    /// 자동분류 사용여부 확인
    /// </summary>
    private void AutoFiltering()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListUserFiltering";

            Cmd.Parameters.Clear();
            
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            OleDbDataReader reader = Cmd.ExecuteReader();
            
            if (reader.HasRows)
                strAutoFilteringMsg = "<b><font color=\"#ff0000\">사용중</font></b>";
            else
                strAutoFilteringMsg = "<font color=\"0000ff\">사용안함</font>";

            reader.Close();
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox(e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    #region 수신거부 사용여부 확인
    /// <summary>
    /// 수신거부 사용여부 확인
    /// </summary>
    private void EmailReject()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListRejectEmailAddr";

            Cmd.Parameters.Clear();

            // 현재 페이지
            Param = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            // 출력할 게시물 수
            Param = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            // 사용자 아이디
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // 도메인 명
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            //2010.03.09 검색 기능을 위해서 추가함,
            // 검색 명
            Param = Cmd.Parameters.Add("@varsch", OleDbType.VarChar, 0);
            Param.Direction = ParameterDirection.Input;

            // 리턴값
            Param = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            Param.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = 1;
            Cmd.Parameters["@iPageSize"].Value = 1;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            //2010.03.09 검색 기능을 위해서 추가함,
            Cmd.Parameters["@varsch"].Value = "";

            Cmd.ExecuteNonQuery();

            int iTotalCount = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            if (iTotalCount > 0)
                strEmailRejectMsg = "<b><font color=\"#ff0000\">사용중 (" + iTotalCount.ToString() + ")</font></b>";
            else
                strEmailRejectMsg = "<font color=\"0000ff\">사용안함</font>";
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox(e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    #region 메일 리스트 데이터 바인드
    /// <summary>
    /// 받은편지함에 있는 메일 상위 N 개 목록만 보여준다.
    /// </summary>
    private void MailListBind(ref Repeater rpt, ref HtmlTable table, int iMailboxIdx, int iMailCount)
    {
        int iRowCount = 0;
        int iCnt = 0;
        NewMails newMails = new NewMails();
        DataTable dt = new DataTable();

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectTopNMail";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iCount", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMailboxIdx"].Value = iMailboxIdx;
            Cmd.Parameters["@iCount"].Value = iMailCount;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "NM_MAIL_CONTENT_" + iMailboxIdx.ToString());

            dt = ds.Tables["NM_MAIL_CONTENT_" + iMailboxIdx.ToString()];

            iRowCount = dt.Rows.Count;

            if (iRowCount > 0)
            {
                string[,] mailInfo = new string[iRowCount, 6];

                foreach (DataRow dr in dt.Rows)
                {
                    mailInfo[iCnt, 0] = dr["Mc_Idx"].ToString();
                    mailInfo[iCnt, 1] = dr["Mc_From"].ToString();
                    mailInfo[iCnt, 2] = dr["Mc_Receive_Date"].ToString();
                    mailInfo[iCnt, 3] = dr["Mc_Subject"].ToString();
                    mailInfo[iCnt, 4] = dr["Mc_Size"].ToString();
                    mailInfo[iCnt, 5] = dr["Mc_Mailbox_Idx"].ToString();

                    iCnt++;
                }

                dt.Clear();
                
                dt.Columns.Remove("Mc_Size");
                dt.Columns.Remove("Mc_Idx");
                dt.Columns.Add("Mc_Size", Type.GetType("System.String"));
                dt.Columns.Add("Mc_Idx", Type.GetType("System.String"));
                
                for (iCnt = 0; iCnt < iRowCount; iCnt++)
                {
                    DataRow dr = dt.NewRow();

                    dr["Mc_Idx"] = mailInfo[iCnt, 0];

                    // 보낸이
                    string[] arrTmp = WF.linkMailAddress(mailInfo[iCnt, 1], "writeMail.aspx?email=", 6, "...");

                    dr["Mc_From"] = arrTmp[0];

                    if (dr["Mc_From"].ToString().Trim() == "")
                        dr["Mc_From"] = "&nbsp;";

                    // 받는시각
                    DateTime date = DateTime.Parse(mailInfo[iCnt, 2]);
                    dr["Mc_Receive_Date"] = date.ToString("yyyy-MM-dd");

                    // 제목
                    if (mailInfo[iCnt, 3].Trim() == "")
                        mailInfo[iCnt, 3] = "제목이 없습니다.";
                    else
                        mailInfo[iCnt, 3] = WF.StrCutByte(mailInfo[iCnt, 3], 56, "...");

                    dr["Mc_Subject"] = "<a href=\"viewMail.aspx?mailId=" + mailInfo[iCnt, 0] + "&mailbox=" + mailInfo[iCnt, 5] + "\">" + mailInfo[iCnt, 3] + "</a>";
                    dr["Mc_Size"] = WF.GetFileSize(int.Parse(mailInfo[iCnt, 4]));
                    dr["Mc_Mailbox_Idx"] = mailInfo[iCnt, 5];

                    dt.Rows.Add(dr);
                }
                
                /*
                if (iRowCount < iMailCount)
                {
                    for (iCnt = 0; iCnt < (iMailCount - iRowCount); iCnt++)
                    {
                        DataRow dr = dt.NewRow();
                        dr["Mc_Idx"] = "";
                        dt.Rows.Add(dr);
                    }
                }
                */

                if (iMailboxIdx != 1)
                {
                    if (ds.Relations.IndexOf("Mailbox_" + iMailboxIdx.ToString()) > 0)
                    {
                        DataRelation rel = new DataRelation("Mailbox_" + iMailboxIdx.ToString(),
                                ds.Tables["Main_View_Mailbox"].Columns["M_Idx"],
                                dt.Columns["Mc_Mailbox_Idx"]);

                        ds.Relations.Add(rel);
                    }
                }
                else
                {
                    rpt.DataSource = dt;
                    rpt.DataBind();
                }
            }
            else
            {
                TableDataBind(ref table);

                Page.DataBind();
            }
        }
        catch (Exception e)
        {
            JS.MessageBox("읽지않은 메일 출력 오류: " + e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    private void TableDataBind(ref HtmlTable table)
    {
        if (table != null)
        {
            HtmlTableRow row = new HtmlTableRow();
            HtmlTableCell cell = new HtmlTableCell();

            table.Border = 0;

            row.BgColor = "#93b2dd";
            row.Height = "2";
            cell.ColSpan = 4;
            row.Cells.Add(cell);
            table.Rows.Add(row);

            row = new HtmlTableRow();
            row.BgColor = "#93b2dd";
            row.Height = "23";

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">보낸사람</font></b>";
            cell.Width = "100";
            cell.Align = "center";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">제&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;목</font></b>";
            cell.Align = "center";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">날짜</font></b>";
            cell.Width = "80";
            cell.Align = "center";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">용량</font></b>";
            cell.Width = "80";
            cell.Align = "center";
            row.Cells.Add(cell);

            table.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            row.BgColor = "#E5E5E5";
            row.Height = "1";
            cell.ColSpan = 4;
            row.Cells.Add(cell);

            table.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            row.Height = "120";
            cell.ColSpan = 4;
            cell.Align = "center";
            cell.InnerHtml = "읽지 않은 새 편지가 없습니다.";
            row.Cells.Add(cell);

            table.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            row.BgColor = "#E5E5E5";
            row.Height = "2";
            cell.ColSpan = 4;
            row.Cells.Add(cell);
            table.Rows.Add(row);

            table.DataBind();
        }
    }

    private void MainViewMailBox()
    {
        string[,] strMainViewMailbox = null;
        int iRowCnt = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsDefault", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsMainView", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@strIsDefault"].Value = "";
            Cmd.Parameters["@strIsMainView"].Value = "Y";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "Main_View_Mailbox");
            dt = ds.Tables["Main_View_Mailbox"];
            iRowCnt = dt.Rows.Count;

            if (iRowCnt > 0)
            {
                strMainViewMailbox = new string[iRowCnt, 5];

                for (int i = 0; i < iRowCnt; i++)
                {
                    DataRow dr = dt.Rows[i];

                    strMainViewMailbox[i, 0] = dr["Mailbox_No"].ToString();
                    strMainViewMailbox[i, 1] = dr["M_Idx"].ToString();
                    strMainViewMailbox[i, 2] = dr["M_Mailbox_Name"].ToString();
                    strMainViewMailbox[i, 3] = dr["M_No_Read_Count"].ToString();
                    strMainViewMailbox[i, 4] = dr["M_Main_View_Count"].ToString();
                }

                dt.Rows.Clear();
                dt.Columns.Clear();

                dt.Columns.Add("Mailbox_No", Type.GetType("System.String"));
                dt.Columns.Add("M_Idx", Type.GetType("System.Int16"));
                dt.Columns.Add("M_Mailbox_Name", Type.GetType("System.String"));
                dt.Columns.Add("M_No_Read_Count", Type.GetType("System.String"));
                dt.Columns.Add("M_Main_View_Count", Type.GetType("System.String"));

                for (int i = 0; i < iRowCnt; i++)
                {
                    if (strMainViewMailbox[i, 1] != "1")
                    {
                        DataRow dr = dt.NewRow();

                        dr["Mailbox_No"] = strMainViewMailbox[i, 0];
                        dr["M_Idx"] = int.Parse(strMainViewMailbox[i, 1]);
                        dr["M_Mailbox_Name"] = strMainViewMailbox[i, 2];
                        dr["M_No_Read_Count"] = strMainViewMailbox[i, 3];
                        dr["M_Main_View_Count"] = strMainViewMailbox[i, 4];

                        dt.Rows.Add(dr);
                        HtmlTable table = (HtmlTable)rptMainViewMailbox.FindControl("tblMainViewMailList");
                        //if (table == null) JS.MessageBox("테이블 객체 null");
                        MailListBind(ref rptMainViewMailbox, ref table, int.Parse(strMainViewMailbox[i, 1]), int.Parse(strMainViewMailbox[i, 4]));
                    } else
                        MailListBind(ref rptMailList, ref tblMailList, int.Parse(strMainViewMailbox[i, 1]), int.Parse(strMainViewMailbox[i, 4]));
                }

                rptMainViewMailbox.DataSource = dt;
                rptMainViewMailbox.DataBind();
            }
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox("에러: " + e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }

    #region 최근 게시물 데이터 바인드
    /// <summary>
    /// 최근 게시물 데이터 바인드
    /// </summary>
    private void NewBoardDocDataBind()
    {
        int iRowCnt = 0;
        int iCnt = 0;
        string[,] arrDocInfo = null;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListTop5NewBoardDoc";

            Cmd.Parameters.Clear();

            // 도메인 명
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "DOC_INFO");
            dt = ds.Tables["DOC_INFO"];

            iRowCnt = dt.Rows.Count;

            arrDocInfo = new string[iRowCnt, 7];

            foreach (DataRow dr in dt.Rows)
            {
                arrDocInfo[iCnt, 0] = dr["USER_NAME"].ToString();				// 사용자 이름
                arrDocInfo[iCnt, 1] = dr["DOC_NO"].ToString();					// 게시물 번호
                arrDocInfo[iCnt, 2] = dr["BRD_NO"].ToString();					// 게시판 번호
                arrDocInfo[iCnt, 3] = dr["DOC_SUBJECT"].ToString();				// 게시물 제목
                arrDocInfo[iCnt, 4] = dr["DOC_WRITE_DATE"].ToString();			// 게시물 작성일자
                arrDocInfo[iCnt, 5] = dr["EMAIL"].ToString();					// 메일주소
                arrDocInfo[iCnt, 6] = dr["BRD_NAME"].ToString();				// 게시판 이름
                ++iCnt;
            }

            dt.Clear();
            dt.Columns.Remove("EMAIL");
            dt.Columns.Remove("DOC_NO");
            dt.Columns.Remove("BRD_NO");

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();

                // 글 작성자 메일 주소 링크
                dr["USER_NAME"] = "<a href=\"WriteMail.aspx?email=" + arrDocInfo[iLoop, 5] + "\">" + arrDocInfo[iLoop, 0] + "</a>";
                // 글 작성 일자
                dr["DOC_WRITE_DATE"] = arrDocInfo[iLoop, 4];
                // 제목에 게시물 보기 링크 걸기
                arrDocInfo[iLoop, 3] = "<a href=\"../Board/ViewDoc.aspx?brdNo=" + arrDocInfo[iLoop, 2] + "&docNo=" + arrDocInfo[iLoop, 1] +
                    "\">" + WF.StrCutByte(arrDocInfo[iLoop, 3], 45, "..") + "</a>";
                dr["DOC_SUBJECT"] = arrDocInfo[iLoop, 3];
                // 게시판 명
                dr["BRD_NAME"] = "[" + arrDocInfo[iLoop, 6] + "]";

                dt.Rows.Add(dr);
            }

            rptNewBoardDoc.DataSource = dt.DefaultView;
            rptNewBoardDoc.DataBind();
        }
        catch (Exception err)
        {
            JS.MessageBox("최근 등록된 게시물을 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
        finally
        {
            Con.Close();
            CommandInit();
        }
    }
    #endregion

    #region 오늘 일정 데이터 바인드
    /// <summary>
    /// 오늘 일정 데이터 바인드
    /// </summary>
    private void ScheduleDataBind()
    {
        DateTime dt = DateTime.Now;
        DataTable dTable = new DataTable();

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            return;
        }

        try
        {
            
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prWeekSchedule";
            
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@chrFirstWeekDay", OleDbType.Char, 10);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@chrLastWeekDay", OleDbType.Char, 10);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrFirstWeekDay"].Value = WeekDays(dt, true).ToString("yyyy-MM-dd");
            Cmd.Parameters["@chrLastWeekDay"].Value = WeekDays(dt, false).ToString("yyyy-MM-dd");

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SCHEDULE");
            dTable = ds.Tables["SCHEDULE"];

            int iRowCnt = dTable.Rows.Count;

            if (iRowCnt > 0)
            {
                string[,] arrSchedule = new string[iRowCnt, 7];

                for (int iCnt = 0; iCnt < iRowCnt; iCnt++)
                {
                    arrSchedule[iCnt, 0] = dTable.Rows[iCnt]["SCH_NO"].ToString();
                    arrSchedule[iCnt, 1] = dTable.Rows[iCnt]["SCH_ST_HOUR"].ToString() + ":" + dTable.Rows[iCnt]["SCH_ST_MINUTE"].ToString();
                    arrSchedule[iCnt, 2] = dTable.Rows[iCnt]["SCH_ED_HOUR"].ToString() + ":" + dTable.Rows[iCnt]["SCH_ED_MINUTE"].ToString();
                    arrSchedule[iCnt, 3] = dTable.Rows[iCnt]["SCH_TITLE"].ToString();
                    arrSchedule[iCnt, 4] = dTable.Rows[iCnt]["SCH_PUBLIC"].ToString();
                    arrSchedule[iCnt, 5] = dTable.Rows[iCnt]["SOL_MONTH"].ToString();
                    arrSchedule[iCnt, 6] = dTable.Rows[iCnt]["SOL_DAY"].ToString();
                }

                dTable.Clear();
                dTable.Columns.Remove("SCH_ST_HOUR");
                dTable.Columns.Remove("SCH_ED_HOUR");
                dTable.Columns.Add("SCH_HOUR", Type.GetType("System.String"));
                dTable.Columns.Add("SCH_YEAR", Type.GetType("System.String"));

                for (int iCnt = 0; iCnt < iRowCnt; iCnt++)
                {
                    DataRow dr = dTable.NewRow();

                    dr["SCH_NO"] = arrSchedule[iCnt, 0];
                    dr["SCH_HOUR"] = "[" + arrSchedule[iCnt, 5] + "월 " + arrSchedule[iCnt, 6] + "일] " + arrSchedule[iCnt, 1] + " ~ " + arrSchedule[iCnt, 2];
                    dr["SCH_TITLE"] = WF.StrCut(arrSchedule[iCnt, 3], 10, "..");
                    dr["SCH_YEAR"] = dt.Year.ToString();
                    dr["SOL_MONTH"] = dt.Month.ToString();
                    dr["SOL_DAY"] = dt.Day.ToString();
                    dr["SCH_PUBLIC"] = arrSchedule[iCnt, 4];

                    dTable.Rows.Add(dr);
                }

                rptTodaySchedule.DataSource = dTable.DefaultView;
                rptTodaySchedule.DataBind();
            }
            else
            {
                HtmlTableRow row = new HtmlTableRow();
                HtmlTableCell cell = new HtmlTableCell();

                row.Height = "100";
                cell.InnerHtml = "등록된 일정이 없습니다.";
                cell.Align = "center";
                row.Cells.Add(cell);

                tblSchedule.Rows.Add(row);

                Page.DataBind();
            }
        }
        catch (Exception err)
        {
            JS.MessageBox("오늘 일정을 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
        finally
        {
            Con.Close();
            CommandInit();
        }
    }
    #endregion

    #region 내 노트 데이터 바인드
    /// <summary>
    /// 내 노트 데이터 바인드
    /// </summary>
    private void NoteDataBind()
    {
        string strNote = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("내 노트 DB Connection Fail!!!\r\n" +
                err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectNote";

            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "USER_NOTE");
            dt = ds.Tables["USER_NOTE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    strNote = dr["NOTE_CONTENT"].ToString();
                    break;
                }
            }
        }
        catch (Exception err)
        {
            Con.Close();
            JS.MessageBox("내 노트를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
        finally
        {
            Con.Close();
            CommandInit();
        }

        tbNote.Text = strNote;
    }
    #endregion

    #region 내 노트 수정
    /// <summary>
    /// 내 노트 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbModifyNote_Click(object sender, EventArgs e)
    {
        string strNoteContent = tbNote.Text;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            JS.MessageBox("내 노트 DB Connection Fail!!!\r\n" +
                err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertNote";

            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varNote", OleDbType.VarWChar, strNoteContent.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varNote"].Value = strNoteContent;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Trans.Rollback();
                JS.MessageBox("내 노트를 수정하는 도중 오류가 발생했습니다.\r\n" +
                    "SQL Error Number: " + iValue.ToString());
                JS.HistoryBack();
                return;
            }
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            JS.MessageBox("내 노트를 수정하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
        finally
        {
            Trans.Commit();
            Con.Close();
            CommandInit();
        }

        Response.Redirect("Main.aspx");
    }
    #endregion

    #region Command 객체 초기화
    /// <summary>
    /// Command 객체 초기화
    /// </summary>
    private void CommandInit()
    {
        Cmd.Parameters.Clear();

    }
    #endregion

    #region 메일 삭제
    /// <summary>
    /// 메일 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDeleteMail_Click(object sender, ImageClickEventArgs e)
    {
        string strValue = hidMailFileInfo.Value;


        if (strValue != "")
        {
            strValue = strValue.Replace("∥", ",");

            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox("DB Connection Fail!!!\r\n" +
                    err.Message);
                JS.MovePage("Main.aspx");
                return;
            }

            try
            {
                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prMoveMailbox";

                Cmd.Parameters.Clear();

                Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strMailIdx", OleDbType.VarChar, strValue.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strMailIdx"].Value = strValue;
                Cmd.Parameters["@iMailboxIdx"].Value = 201;

                Cmd.ExecuteNonQuery();

                int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                if (iResult != 0)
                {
                    if (iResult == -1)
                    {
                        Trans.Rollback();
                        Con.Close();
                        JS.MessageBox("사용자 정보가 없습니다.");
                        return;
                    }
                    else if (iResult == -2)
                    {
                        Trans.Rollback();
                        Con.Close();
                        JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                        return;
                    }
                    else if (iResult == -3)
                    {
                        Trans.Rollback();
                        Con.Close();
                        JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                        return;
                    }
                }

                Trans.Commit();
            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox("선택된 메일을 삭제하는 도중 오류가 발생했습니다.\r\n" +
                    err.Message);
                JS.MovePage("Main.aspx");
                return;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }
        }

        JS.MovePage("Main.aspx");
    }
    #endregion

    #region 수신거부
    /// <summary>
    /// 수신거부
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibRejectMail_Click(object sender, ImageClickEventArgs e)
    {
        string strValue = hidMailFileInfo.Value;
        string[] strMailInfo = strValue.Split('∥');
        string strReject = hidAddReject.Value;
        string strMailbox = hidMailbox.Value;
        string strRejectEmail = "";
        int iResult = 0;
        
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.MovePage("Main.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;

            if (strReject.ToLower() == "yes")
            {
                for (int i = 0; i < strMailInfo.Length; i++)
                {
                    // 수신거부할 메일의 보낸이 주소를 가져온다.
                    Cmd.CommandText = "prViewMailContent";

                    Cmd.Parameters.Clear();

                    Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                    Param.Direction = ParameterDirection.ReturnValue;

                    Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                    Param.Direction = ParameterDirection.Input;

                    Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                    Param.Direction = ParameterDirection.Input;

                    Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
                    Param.Direction = ParameterDirection.Input;

                    Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                    Param.Direction = ParameterDirection.Input;

                    Cmd.Parameters["@strUserId"].Value = strUserId;
                    Cmd.Parameters["@strDomain"].Value = strDomain;
                    Cmd.Parameters["@iMcIdx"].Value = int.Parse(strMailInfo[i]);
                    Cmd.Parameters["@iMailboxIdx"].Value = 1;

                    OleDbDataReader reader = Cmd.ExecuteReader();

                    if (Cmd.Parameters["@iResult"].Value != null)
                    {
                        iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                        // 에러처리
                    }
                    else
                    {
                        if (reader.HasRows)
                        {
                            reader.Read();
                            strRejectEmail = reader["Mc_From"].ToString();
                        }
                    }

                    reader.Close();

                    if (strRejectEmail == "")
                    {

                        JS.MessageBox("선택된 메일을 수신거부에 등록하는 도중 오류가 발생했습니다.\r\n해당하는 메일이 있는지 확인해보십시오");
                        JS.MovePage("Main.aspx");
                        return;
                    }

                    // 메일주소 외에 다른 문자는 제거한다.
                    // 이름 또는 <> 문자를 제거한다.
                    if (strRejectEmail.LastIndexOf(" ") > -1)
                    {
                        int iPos = 0;
                        strRejectEmail = strRejectEmail.Substring(strRejectEmail.LastIndexOf(" ") + 1);

                        iPos = strRejectEmail.LastIndexOf("|");
                        if (iPos > 0)
                            strRejectEmail = strRejectEmail.Substring(iPos + 1);

                        iPos = strRejectEmail.IndexOf("<");
                        if (iPos > 0)
                            strRejectEmail = strRejectEmail.Substring(iPos + 1);

                        if (strRejectEmail.StartsWith("<"))
                            strRejectEmail = strRejectEmail.Substring(1);

                        iPos = strRejectEmail.LastIndexOf(">");
                        if (iPos > 0)
                            strRejectEmail = strRejectEmail.Substring(0, iPos);
                    }

                    Cmd.Parameters.Clear();
                    Cmd.CommandText = "prInsertRejectEmail";

                    // Command Parameter (Execute Return Value)
                    Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                    Param.Direction = ParameterDirection.ReturnValue;

                    // Command Parameter (User Id)
                    Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                    Param.Direction = ParameterDirection.Input;

                    // Command Parameter (Domain)
                    Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                    Param.Direction = ParameterDirection.Input;

                    // Command Parameter (Reject Email Address)
                    Param = Cmd.Parameters.Add("@varRejectEmail", OleDbType.VarChar, 512);
                    Param.Direction = ParameterDirection.Input;

                    // Command Parameter (Output Value)
                    Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
                    Param.Direction = ParameterDirection.Output;

                    // Command Parameter Value Setting
                    Cmd.Parameters["@varUserId"].Value = strUserId;
                    Cmd.Parameters["@varDomain"].Value = strDomain;
                    Cmd.Parameters["@varRejectEmail"].Value = strRejectEmail;

                    Cmd.ExecuteNonQuery();

                    iResult = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                    if (iResult < 0)
                    {
                        Trans.Rollback();
                        JS.MessageBox("스팸 메일 주소를 등록하는 도중 오류가 발생했습니다.\r\n" +
                            "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                        JS.MovePage("Main.aspx");
                        return;
                    }
                    else if (iResult != 0)
                    {
                        Trans.Rollback();
                        JS.MessageBox("스팸 메일 주소를 삭제하는 도중 오류가 발생했습니다.\r\n" +
                            "SQL Error Number: " + iResult.ToString());
                        JS.MovePage("Main.aspx");
                        return;
                    }
                }
            }

            strValue = strValue.Replace("∥", ",");
            
            Cmd.Parameters.Clear();

            Cmd.CommandText = "prMoveMailbox";
            
            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strMailIdx", OleDbType.VarChar, strValue.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@strMailIdx"].Value = strValue;
            Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailbox);

            Cmd.ExecuteNonQuery();

            iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                if (iResult == -1)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("사용자 정보가 없습니다.");
                    return;
                }
                else if (iResult == -2)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                    return;
                }
                else if (iResult == -3)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                    return;
                }
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            JS.MessageBox("선택된 메일을 수신거부에 등록하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("Main.aspx");
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
        
        JS.MovePage("Main.aspx");
    }
    #endregion

    protected void rptMainViewMailbox_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        int iCnt = e.Item.Controls.Count;

        try
        {
            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {
                for (int i = 0; i < iCnt; i++)
                {
                    HiddenField hfItem = (HiddenField)e.Item.FindControl("hfMailboxIdx");
                    HtmlTable table = (HtmlTable)e.Item.FindControl("tblMainViewMailList");

                    if (table != null && hfItem != null)
                    {
                        if (hfItem.Value != "" && hfItem.Value != "1")
                        {
                            Repeater repeater = (Repeater)e.Item.FindControl("rptViewMail");

                            if (repeater != null)
                            {
                                if (ds.Tables["NM_MAIL_CONTENT_" + hfItem.Value].DefaultView.Count > 0)
                                {
                                    repeater.DataSource = ds.Tables["NM_MAIL_CONTENT_" + hfItem.Value].DefaultView;
                                    repeater.DataBind();
                                }
                            }
                            
                        }
                    }
                }
            }
        }
        catch (Exception err)
        {
            JS.MessageBox(err.Message);
            return;
        }
    }

    private DateTime WeekDays(DateTime dt, bool isFirst)
    {
        DateTime date;
        int iDiff = 0;

        switch (dt.DayOfWeek)
        {
            case DayOfWeek.Sunday:
                iDiff = 0;
                break;
            case DayOfWeek.Monday:
                iDiff = 1;
                break;
            case DayOfWeek.Tuesday:
                iDiff = 2;
                break;
            case DayOfWeek.Wednesday:
                iDiff = 3;
                break;
            case DayOfWeek.Thursday:
                iDiff = 4;
                break;
            case DayOfWeek.Friday:
                iDiff = 5;
                break;
            case DayOfWeek.Saturday:
                iDiff = 6;
                break;
        }

        if (isFirst)
            date = dt.Date.AddDays(iDiff * -1);
        else
            date = dt.Date.AddDays(6 - iDiff);

        return date;
    }
}
