﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Net;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;


public partial class Mail_WriteMail : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private MailParser mParser = null;
    private UserInfo UI;
    private JavaScript JS;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMailId = "";
    private string strType = "";
    private string mTo = "";
    private string mCc = "";
    private string mSubject = "";
    private string mContent = "";
    protected string strUserId = "";
    protected string strDomain = "";
    protected string strEnc = "";
    protected string strMailBox = "";
    protected string strSign1 = "";
    protected string strSign2 = "";
    protected string strSign3 = "";
    protected string strHttpUrlRoot = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strEmail = Request.Params["email"];
        
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailId = Request.Params["mailId"];
        strMailBox = Request.Params["Mailbox"];
        strType = Request.Params["Type"];

        Response.ContentEncoding = Encoding.UTF8;
        Request.ContentEncoding = Encoding.UTF8;

        UI = new UserInfo(strUserId, strDomain, strCon);

        string NowUrl = Request.Url.ToString();

        if (NowUrl != "")
        {
            int ipos = NowUrl.LastIndexOf("/");

            if (ipos > -1)
            {
                strHttpUrlRoot = NowUrl.Substring(0, ipos);
            }
        }

     
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        if (!IsPostBack)
        {
            AuthKey ak = new AuthKey();
            string strMsg = ak.CheckUserCount(UI.TotalUserCount(strDomain));

            if (strMsg != "")
                JS.MessageBox(strMsg);

            if (strMailId != null && strMailBox != null)
            {
                // 메일파일명과 메일박스명이 존재할때 해당 메일을 파싱해서
                // 쓰기폼으로 되돌려 준다.
                if (strMailId != "" && strMailBox != "")
                {
                    this.ThisMailParse();
                }
                hidMailId.Value = strMailId;
                hidMailBox.Value = strMailBox;
                hidType.Value = strType;
            }

            // 답장일 경우 보낸사람 주소를 넣는다.
            if (strType != null)
            {
                if (strType.ToLower() == "re" || strType.ToLower() == "ar")
                {
                    txtSendTo.Text = mTo;
                    txtSendCc.Text = mCc;
                }

                if (strType != "")
                    hidContent.Value = mContent;
            }
            else
            {
                if (strEmail != null)
                    mTo = strEmail;

                txtSendTo.Text = mTo;

                if (mCc != null)
                    txtSendCc.Text = mCc;

                hidContent.Value = mContent;
            }

            txtSendBcc.Text = "";
            //txtSendCc.Text = "";
            txtMailSubject.Text = mSubject;

            WebFunction WF = new WebFunction();
            mContent = WF.ChkContent_InsertCid0000(mContent, strHttpUrlRoot);

            //본문내용을 넣는부분
            this.mf_body_html.Value = mContent;

            Signature();
            Page.DataBind();

            DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");

            foreach (FileInfo fi in di.GetFiles())
            {
                if (di.Exists)
                {
                    di.Delete(true);
                    di.Create();
                    break;
                }
            }
        }
    }

    #region 회신, 전체회신, 전달시 또는 임시 저장메일 파싱
    /// <summary>
    /// 회신, 전체회신, 전달시 또는 임시 저장메일 파싱한다.
    /// </summary>
    private void ThisMailParse()
    {
        string strContent = null;
        string msgHeader = "";
        string strMailboxNo = "";
        string strSubject = "";
        string strFrom = "";
        string strTo = "";
        string strCc = "";
        string strContentHtml = "";
        string strContentText = "";
        string strReceiveDate = "";
        string strMailFile = "";
        int iAttachCount = 0;
        OleDbDataReader reader;
        WebFunction WF = new WebFunction();

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewMailContent";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMcIdx"].Value = int.Parse(strMailId);
            Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

            reader = Cmd.ExecuteReader();

            if (Cmd.Parameters["@iResult"].Value != null)
            {
                int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                // 에러처리
            }
            else
            {
                if (reader.HasRows)
                {
                    reader.Read();
                    
                    strMailboxNo = reader["Mc_Mailbox_No"].ToString();
                    strSubject = reader["Mc_Subject"].ToString();
                    strFrom = reader["Mc_From"].ToString();
                    strTo = reader["Mc_To"].ToString();
                    strCc = reader["Mc_Cc"].ToString();
                    strContentHtml = reader["Mc_Body_Html"].ToString();
                    strContentText = reader["Mc_Body_Text"].ToString();
                    iAttachCount = int.Parse(reader["Mc_Attach_Count"].ToString());
                    strReceiveDate = reader["Mc_Receive_Date"].ToString();
                    strMailFile = reader["Mc_Filename"].ToString();

                    hidMailBoxNo.Value = strMailboxNo;
                    hidMailFile.Value = strMailFile;
                }
            }

            reader.Close();
        }catch (Exception e)
        {
            JS.MessageBox(e.Message);
            JS.HistoryBack();
            return;
        }
        
        try
        {
            if (iAttachCount > 0)
            {
                Cmd.Parameters.Clear();
                Cmd.CommandText = "prListAttachFiles";

                Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strMailFile", OleDbType.VarChar, strMailFile.Length);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strMailFile"].Value = strMailFile;

                reader = Cmd.ExecuteReader();

                if (reader.HasRows)
                {
                    while (reader.Read())
                    {
                        string sFileName = reader["Ma_Attach_File"].ToString();
                        string strAttachFile = sFileName;

                        if (strAttachFile.Trim() != "")
                        {
                            if (strAttachFile.StartsWith(" "))
                                strAttachFile = strAttachFile.Substring(1);

                            strAttachFile = strAttachFile.Replace("'", "\\'");

                            if (sFileName.StartsWith(" "))
                                sFileName = sFileName.Substring(1);

                            // 첨부파일 임시 저장 폴더에 저장
                            if (!Directory.Exists(UI.UserPath + "\\attach_temp"))
                                Directory.CreateDirectory(UI.UserPath + "\\attach_temp");

                            MailParser mParser = new MailParser(UI.UserPath, strMailboxNo, strMailFile);

                            string CidNameTemp = "";

                            CidNameTemp = mParser.CidFileSave(UI.UserPath + "\\attach_temp\\", UI.UserPath + "\\" + strMailboxNo + "\\" + strMailFile, sFileName, UI.UserPath + "\\cid_temp\\");

                            //2010.03.08 Cid 이미지가 있으면 Cid 이미지이름을 가져 오기
                            if (CidNameTemp != "")
                            {
                                this.hidCid.Value += sFileName + "|";
                            }
                        }
                    }
                }
                reader.Close();
            }

            // 전달 또는 답장이 아닐때 파싱한 주소를 쓰기폼으로 돌려준다.
            if (strType == null)
            {
                mSubject = strSubject;
                mTo = strTo.Replace("|", " ").Replace("<", "").Replace(">", "");
                mTo = mTo.Replace(";", ",");
                
                if (mTo.EndsWith(","))
                    mTo = mTo.Substring(0, mTo.Length - 1);

                if (strCc != null)
                    mCc = strCc.Replace("|", " ").Replace("<", "").Replace(">", "");
            }
            else
            {
                // 2008년 11월 26일
                // 회신 또는 전달일 때 제목 입력하는 부분에 제목이 빠지는 문제때문에 수정.
                mSubject = strSubject;

                // 쓰기 또는 전달일때
                if (strType.ToLower() == "re")
                {
                    mSubject = "Re: " + mSubject;
                    mTo = strFrom.Replace("|", " ");
                }
                else if (strType.ToLower() == "ar")
                {
                    mSubject = "Re: " + mSubject;
                    // Sender Email Address (Mail From)

                    //2010.02.01 from 값을 집어 넣을때 본인 아이디가 있으면 제외 시킨다.
                    //mTo = strFrom.Replace("|", " ");
                    if (strFrom.Replace("|", " ").IndexOf(strUserId + "@" + strDomain) < 0)
                        mTo = strFrom.Replace("|", " ");

                    //2010.02.01 받는사람.
                    // Received Email Address (Mail To)
                    if (strTo != null && strTo != "")
                    {
                        string strValue = "";
                        //2010.02.01 DB에 들어 가 있는구분자는 ; 이다.
                        //string[] strTmp = strTo.Split(',');
                        string[] strTmp = strTo.Split(';');

                        //JS.MessageBox(strTmp.Length.ToString());

                        // 받는사람 메일 주소에 사용자 메일주소가 존재하는지 체크
                        // 존재하면 사용자 메일주소는 제외한다.
                        for (int iCnt = 0; iCnt < strTmp.Length; iCnt++)
                        {
                            if (strTmp[iCnt].IndexOf(strUserId + "@" + strDomain) < 0)
                                strValue += strTmp[iCnt] + ",";
                        }

                        //2010.02.01 indexOf는 처음 시작값이다. 마지막값을 알려면 LastIndexOf 이다.
                        // 문자열 마지막에 콤마(,)가 존재하면 제거한다.
                        //if (strValue.Length == strValue.IndexOf(","))
                        if (strValue != "")
                        {
                            if (strValue.Length == strValue.LastIndexOf(",") + 1)
                                strValue = strValue.Substring(0, strValue.Length - 1);
                        }
                        //2010.02.01 합혀지는 값을 strValue와 mTo 값이다.
                        //mTo += "," + strTo.Replace("|", " ");

                        if (mTo == "")
                        {
                            if (strValue != "")
                                mTo += strValue;
                            else
                                mTo = mTo;
                        }
                        else
                        {
                            if (strValue != "")
                                mTo += "," + strValue;
                            else
                                mTo = mTo;
                        }

                    }
                    //2010.02.01 참조.
                    // 기존에는 받는사람으로 들어 갔는데 참조는 참조로 들어 가며 참조일때도 사용자 메일주소가 존재하면 제외 시키는 루틴 추가함.
                    // Received Email Address (Mail Cc)
                    //if (strCc != null && strCc != "")
                    //    mTo += "," + strCc.Replace("|", " ");
                    if (strCc != null && strCc != "")
                    {
                        string strValue2 = "";
                        //2010.02.01 DB에 들어 가 있는구분자는 ; 이다.
                        //string[] strTmp = strTo.Split(',');
                        string[] strTmp2 = strCc.Split(';');

                        //JS.MessageBox(strTmp.Length.ToString());

                        // 받는사람 메일 주소에 사용자 메일주소가 존재하는지 체크
                        // 존재하면 사용자 메일주소는 제외한다.
                        for (int iCnt = 0; iCnt < strTmp2.Length; iCnt++)
                        {
                            if (strTmp2[iCnt].IndexOf(strUserId + "@" + strDomain) < 0)
                                strValue2 += strTmp2[iCnt] + ",";
                        }

                        //2010.02.01 indexOf는 처음 시작값이다. 마지막값을 알려면 LastIndexOf 이다.
                        // 문자열 마지막에 콤마(,)가 존재하면 제거한다.
                        //if (strValue.Length == strValue.IndexOf(","))
                        if (strValue2 != "")
                        {
                            if (strValue2.Length == strValue2.LastIndexOf(",") + 1)
                                strValue2 = strValue2.Substring(0, strValue2.Length - 1);
                        }

                        if (strValue2 != "")
                            mCc = strValue2;
                    }
                }
                else if (strType.ToLower() == "fw")
                {
                    mSubject = "Fw: " + mSubject;

                    if (iAttachCount > 0)
                    {

                        Cmd.Parameters.Clear();
                        Cmd.CommandText = "prListAttachFiles";

                        Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                        Param.Direction = ParameterDirection.ReturnValue;

                        Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                        Param.Direction = ParameterDirection.Input;

                        Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                        Param.Direction = ParameterDirection.Input;

                        Param = Cmd.Parameters.Add("@strMailFile", OleDbType.VarChar, strMailFile.Length);
                        Param.Direction = ParameterDirection.Input;

                        Cmd.Parameters["@strUserId"].Value = strUserId;
                        Cmd.Parameters["@strDomain"].Value = strDomain;
                        Cmd.Parameters["@strMailFile"].Value = strMailFile;
                        
                        reader = Cmd.ExecuteReader();
                        
                        if (reader.HasRows)
                        {
                            bool bEnd = false;

                            HtmlTableRow row = new HtmlTableRow();
                            HtmlTableCell cell = new HtmlTableCell();

                            cell.ColSpan = 2;
                            cell.InnerHtml = "<font color=\"blue\" style=\"fone-size:9pt;\">※ <b>첨부되는 파일이 있습니다.</b></font>";

                            row.Cells.Add(cell);
                            tblAttachFiles.Rows.Add(row);

                            while (reader.Read())
                            {
                                string sFileName = reader["Ma_Attach_File"].ToString();
                                string strAttachFile = sFileName;
                                
                                if (strAttachFile.Trim() != "")
                                {
                                    if (strAttachFile.StartsWith(" "))
                                        strAttachFile = strAttachFile.Substring(1);
                                    
                                    strAttachFile = strAttachFile.Replace("'", "\\'");
                                    
                                    if (sFileName.StartsWith(" "))
                                        sFileName = sFileName.Substring(1);

                                    if (!bEnd)
                                    {
                                        row = new HtmlTableRow();
                                        bEnd = true;
                                    }
                                    else
                                    {
                                        tblAttachFiles.Rows.Add(row);
                                        bEnd = false;
                                    }

                                    cell = new HtmlTableCell();
                                    cell.Width = "50%";
                                    cell.InnerHtml = "<input type=\"checkbox\" checked id=\"cbFwFile\" name=\"cbFwFile\" onclick=\"javascript: obj_Checked(this.checked, this.value, 'hidFwFile', ':');\" value=\'" + sFileName + "'\">" + sFileName;
                                    row.Cells.Add(cell);

                                    this.hidFwFile.Value += sFileName + ":";
                                }
                            }

                            if (bEnd)
                            {
                                cell = new HtmlTableCell();
                                cell.Width = "50%";
                                cell.InnerHtml = "&nbsp;";
                                row.Cells.Add(cell);

                                tblAttachFiles.Rows.Add(row);
                            }
                        }

                        reader.Close();
                    }
                    else
                        tblAttachFiles.Visible = false;
                }
                else
                    mSubject = strSubject;
            }

            if (strContentHtml != "")
            {
                if (strType != null)
                {
                    if (strType.ToLower() == "fw")
                        msgHeader = "<br>\r\n<br>\r\n---------- Original Message ----------<br>\r\n";
                    else
                        msgHeader = "<br>\r\n<br>\r\n<hr><br>\r\n";

                    msgHeader += "From: " + WF.linkMailAddress(strFrom) + "<br>\r\n" +
                        "To: " + WF.linkMailAddress(strTo.Replace(";", ",")) + "<br>\r\n" +
                        "Sent: " + strReceiveDate + "<br>\r\n" +
                        "Subject: " + strSubject + "<br><br><br>\r\n";
                }

                strContent = strContentHtml;
            }
            else
            {
                if (strType != null)
                {
                    if (strType.ToLower() == "fw")
                        msgHeader = "---------- Original Message ----------<br>\r\n";
                    else
                        msgHeader = "<hr>\r\n";

                    msgHeader += "From: " + strFrom + "\r\n" +
                        "To: " + strTo.Replace(";", ",") + "\r\n" +
                        "Sent: " + strReceiveDate + "\r\n" +
                        "Subject: " + strSubject + "\r\n\r\n";
                }

                strContent = strContentText;
                strContent = strContent.Replace("<", "&lt");
                strContent = strContent.Replace("\r\n", "<br>\r\n");
            }
        }
        catch (Exception err)
        {
            // 오류 처리
            string strMsg = "";

            if (strType == null)
                strMsg = "임시 저장 편지 ";
            else if (strType.ToLower() == "re")
                strMsg = "회신";
            else if (strType.ToLower() == "ar")
                strMsg = "전체회신";
            else if (strType.ToLower() == "fw")
                strMsg = "전달";

            JS.MessageBox(strMsg + " 중인 메일을 파싱하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        mContent = msgHeader + strContent;
    }
    #endregion

    #region 본문 내용을 hidContent에 넣는다.
    /// <summary>
    /// 본문 내용을 hidContent에 넣는다.
    /// </summary>
    private string ContentValue()
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("	var getDocument = document.getElementById(\"wysiwygtxtEditor\").contentWindow.document;");
        sb.Append("");
        sb.Append("	if (document.frmWriteMail.chkWriteType[0].checked)");
        sb.Append("	{");
        sb.Append("		document.frmWriteMail.hidWriteType.value = 'Text';");
        sb.Append("		document.frmWriteMail.hidContent.value = document.frmWriteMail.txtTextContent.value;");
        sb.Append("	}");
        sb.Append("	else if (document.frmWriteMail.chkWriteType[1].checked)");
        sb.Append("	{");
        sb.Append("		document.frmWriteMail.hidWriteType.value = 'Html';");
        sb.Append("		document.frmWriteMail.hidContent.value = getDocument.body.innerHTML;");
        sb.Append("	}");

        return sb.ToString();
    }
    #endregion

    #region 그룹 확인
    private string CheckGroup(string strMailAddr)
    {
        string[] arrValue = null;
        string strValue = "";
        int iCnt = 0;

        if (strMailAddr == "") return "";

        arrValue = strMailAddr.Split(';');
        iCnt = arrValue.Length;

        if (iCnt > -1)
        {
            for (int iLoop = 0; iLoop < iCnt; iLoop++)
            {
                // 2006년 12월 22일 수정
                // 메일주소값이 빈문자열 일때 해당 루틴을 건너뛰도록 함.
                if (arrValue[iLoop].Trim() != "")
                {
                    if (arrValue[iLoop].Substring(0, 1) == "⊙")
                        strValue += this.GetGroupAddr(arrValue[iLoop].Substring(1));
                    else
                        strValue += arrValue[iLoop] + ";";
                }
            }

            if (strValue.Trim() != "")
                strValue = strValue.Substring(0, strValue.LastIndexOf(";"));
        }

        return strValue;
    }
    #endregion

    #region 그룹에 등록된 주소를 가져온다.
    /// <summary>
    /// 그룹에 등록된 메일 주소를 가져온다.
    /// </summary>
    /// <param name="strGroup"></param>
    /// <returns></returns>
    private string GetGroupAddr(string strGroup)
    {
        string strAddr = "";
        string strCommon = "";

        // 2006년 11월 22일 수정
        // 그룹 메일 발송시 공유 그룹으로 발송 못하던 문제 수정
        // 그룹명에 구분자를 넣어서 공유 그룹인지 개인 그룹인지 확인
        if (strGroup.IndexOf("‡") > 0)
        {
            strCommon = strGroup.Substring(strGroup.IndexOf("‡") + 1, 1);
            strGroup = strGroup.Substring(0, strGroup.IndexOf("‡"));
        }
        else
            strCommon = "N";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            return "";
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            Param = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            Param = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, strCommon.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroup;
            Cmd.Parameters["@chrCommon"].Value = strCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            foreach (DataRow dr in dt.Rows)
                strAddr += dr["EMAIL_ADDR"].ToString() + ";";
        }
        catch (Exception err)
        {
            JS.MessageBox(strGroup + " 그룹에서 주소를 가져오는 도중 오류가 발생했습니다.\r\n" +
                "오류 내용: " + err.Message);
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }

        return strAddr;
    }
    #endregion

    #region Temp 폴더 삭제
    private void DeleteTempDirectory(bool bFiles)
    {
        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");
        
        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
    }
    #endregion

    #region 서명정보 바인드
    /// <summary>
    /// 서명정보를 가져온다.
    /// </summary>
    private void Signature()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectSign";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SIGN_INFO");
            dt = ds.Tables["SIGN_INFO"];
            int iRowCount = dt.Rows.Count;

            if (iRowCount > 0)
            {
                strSign1 = dt.Rows[0]["S_SIGN1"].ToString().Replace("\r\n", "<br>\r\n");
                strSign2 = dt.Rows[0]["S_SIGN2"].ToString().Replace("\r\n", "<br>\r\n");
                strSign3 = dt.Rows[0]["S_SIGN3"].ToString().Replace("\r\n", "<br>\r\n");
            }
        }
        catch (Exception err)
        {
            JS.MessageBox("서명 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("WriteMail.aspx");
            return;
        }
    }
    #endregion
}
